<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'AcceptablePaymentCardsInfoType' => '\\StructType\\AcceptablePaymentCardsInfoType',
            'AcceptablePaymentCards' => '\\StructType\\AcceptablePaymentCards',
            'AcceptablePaymentCard' => '\\StructType\\AcceptablePaymentCard',
            'AcceptedPaymentsType' => '\\StructType\\AcceptedPaymentsType',
            'AddressInfoType' => '\\StructType\\AddressInfoType',
            'AddressType' => '\\StructType\\AddressType',
            'StreetNmbr' => '\\StructType\\StreetNmbr',
            'BankAcctType' => '\\StructType\\BankAcctType',
            'BlackoutDateType' => '\\StructType\\BlackoutDateType',
            'CancelInfoRQType' => '\\StructType\\CancelInfoRQType',
            'CancelInfoRSType' => '\\StructType\\CancelInfoRSType',
            'CancelRules' => '\\StructType\\CancelRules',
            'CancelRuleType' => '\\StructType\\CancelRuleType',
            'CommissionType' => '\\StructType\\CommissionType',
            'CommissionableAmount' => '\\StructType\\CommissionableAmount',
            'PrepaidAmount' => '\\StructType\\PrepaidAmount',
            'FlatCommission' => '\\StructType\\FlatCommission',
            'CommissionPayableAmount' => '\\StructType\\CommissionPayableAmount',
            'CompanyNameType' => '\\StructType\\CompanyNameType',
            'ConnectionType' => '\\StructType\\ConnectionType',
            'ConnectionLocation' => '\\StructType\\ConnectionLocation',
            'ContactPersonType' => '\\StructType\\ContactPersonType',
            'CountryNameType' => '\\StructType\\CountryNameType',
            'CustLoyaltyType' => '\\StructType\\CustLoyaltyType',
            'CustomerType' => '\\StructType\\CustomerType',
            'Telephone' => '\\StructType\\Telephone',
            'Address' => '\\StructType\\Address',
            'CitizenCountryName' => '\\StructType\\CitizenCountryName',
            'CustLoyalty' => '\\StructType\\CustLoyalty',
            'DateTimeSpanType' => '\\StructType\\DateTimeSpanType',
            'StartDateWindow' => '\\StructType\\StartDateWindow',
            'EndDateWindow' => '\\StructType\\EndDateWindow',
            'DescriptionsType' => '\\StructType\\DescriptionsType',
            'DirectBillType' => '\\StructType\\DirectBillType',
            'CompanyName' => '\\StructType\\CompanyName',
            'DocumentType' => '\\StructType\\DocumentType',
            'AdditionalPersonNames' => '\\StructType\\AdditionalPersonNames',
            'EmailType' => '\\StructType\\EmailType',
            'EmployeeInfoType' => '\\StructType\\EmployeeInfoType',
            'EquipmentType' => '\\StructType\\EquipmentType',
            'ErrorType' => '\\StructType\\ErrorType',
            'ErrorsType' => '\\StructType\\ErrorsType',
            'FeeType' => '\\StructType\\FeeType',
            'FeesType' => '\\StructType\\FeesType',
            'FlightSegmentBaseType' => '\\StructType\\FlightSegmentBaseType',
            'DepartureAirport' => '\\StructType\\DepartureAirport',
            'ArrivalAirport' => '\\StructType\\ArrivalAirport',
            'FormattedTextSubSectionType' => '\\StructType\\FormattedTextSubSectionType',
            'FormattedTextTextType' => '\\StructType\\FormattedTextTextType',
            'FormattedTextType' => '\\StructType\\FormattedTextType',
            'FreeTextType' => '\\StructType\\FreeTextType',
            'ItemSearchCriterionType' => '\\StructType\\ItemSearchCriterionType',
            'Position' => '\\StructType\\Position',
            'RefPoint' => '\\StructType\\RefPoint',
            'CodeRef' => '\\StructType\\CodeRef',
            'HotelRef' => '\\StructType\\HotelRef',
            'Radius' => '\\StructType\\Radius',
            'LocationGeneralType' => '\\StructType\\LocationGeneralType',
            'LocationType' => '\\StructType\\LocationType',
            'MessageAcknowledgementType' => '\\StructType\\MessageAcknowledgementType',
            'MonetaryRuleType' => '\\StructType\\MonetaryRuleType',
            'MultimediaObjectType' => '\\StructType\\MultimediaObjectType',
            'OperatingAirlineType' => '\\StructType\\OperatingAirlineType',
            'OperationScheduleType' => '\\StructType\\OperationScheduleType',
            'OperationTimes' => '\\StructType\\OperationTimes',
            'OperationTime' => '\\StructType\\OperationTime',
            'OperationSchedulesType' => '\\StructType\\OperationSchedulesType',
            'OperationSchedulePlusChargeType' => '\\StructType\\OperationSchedulePlusChargeType',
            'OperationSchedulesPlusChargeType' => '\\StructType\\OperationSchedulesPlusChargeType',
            'OperationSchedule' => '\\StructType\\OperationSchedule',
            'OriginDestinationInformationType' => '\\StructType\\OriginDestinationInformationType',
            'OriginLocation' => '\\StructType\\OriginLocation',
            'DestinationLocation' => '\\StructType\\DestinationLocation',
            'POS_Type' => '\\StructType\\POS_Type',
            'ParagraphType' => '\\StructType\\ParagraphType',
            'ListItem' => '\\StructType\\ListItem',
            'PaymentCardType' => '\\StructType\\PaymentCardType',
            'CardIssuerName' => '\\StructType\\CardIssuerName',
            'PaymentDetailType' => '\\StructType\\PaymentDetailType',
            'PaymentAmount' => '\\StructType\\PaymentAmount',
            'PaymentAmountInPayCur' => '\\StructType\\PaymentAmountInPayCur',
            'PaymentFormType' => '\\StructType\\PaymentFormType',
            'Voucher' => '\\StructType\\Voucher',
            'LoyaltyRedemption' => '\\StructType\\LoyaltyRedemption',
            'MiscChargeOrder' => '\\StructType\\MiscChargeOrder',
            'Cash' => '\\StructType\\Cash',
            'PaymentRulesType' => '\\StructType\\PaymentRulesType',
            'PersonNameType' => '\\StructType\\PersonNameType',
            'RateQualifierType' => '\\StructType\\RateQualifierType',
            'RateComments' => '\\StructType\\RateComments',
            'ReferencePlaceHolderType' => '\\StructType\\ReferencePlaceHolderType',
            'RelatedTravelerType' => '\\StructType\\RelatedTravelerType',
            'RelativePositionType' => '\\StructType\\RelativePositionType',
            'RestaurantType' => '\\StructType\\RestaurantType',
            'RestaurantDescription' => '\\StructType\\RestaurantDescription',
            'InfoCodes' => '\\StructType\\InfoCodes',
            'InfoCode' => '\\StructType\\InfoCode',
            'CuisineCodes' => '\\StructType\\CuisineCodes',
            'CuisineCode' => '\\StructType\\CuisineCode',
            'SourceType' => '\\StructType\\SourceType',
            'RequestorID' => '\\StructType\\RequestorID',
            'BookingChannel' => '\\StructType\\BookingChannel',
            'SpecialRequestType' => '\\StructType\\SpecialRequestType',
            'SpecialRequest' => '\\StructType\\SpecialRequest',
            'StateProvType' => '\\StructType\\StateProvType',
            'StreetNmbrType' => '\\StructType\\StreetNmbrType',
            'SuccessType' => '\\StructType\\SuccessType',
            'TPA_Extensions_Type' => '\\StructType\\TPA_Extensions_Type',
            'TaxType' => '\\StructType\\TaxType',
            'TaxesType' => '\\StructType\\TaxesType',
            'TelephoneInfoType' => '\\StructType\\TelephoneInfoType',
            'TimeDurationType' => '\\StructType\\TimeDurationType',
            'TimeInstantType' => '\\StructType\\TimeInstantType',
            'TotalType' => '\\StructType\\TotalType',
            'TransportationsType' => '\\StructType\\TransportationsType',
            'Transportations' => '\\StructType\\Transportations',
            'Transportation' => '\\StructType\\Transportation',
            'TravelDateTimeType' => '\\StructType\\TravelDateTimeType',
            'TravelerRPHs' => '\\StructType\\TravelerRPHs',
            'TravelerRPH' => '\\StructType\\TravelerRPH',
            'URL_Type' => '\\StructType\\URL_Type',
            'UniqueID_Type' => '\\StructType\\UniqueID_Type',
            'VendorMessageType' => '\\StructType\\VendorMessageType',
            'VendorMessagesType' => '\\StructType\\VendorMessagesType',
            'VerificationType' => '\\StructType\\VerificationType',
            'PersonName' => '\\StructType\\PersonName',
            'ReservationTimeSpan' => '\\StructType\\ReservationTimeSpan',
            'AssociatedQuantity' => '\\StructType\\AssociatedQuantity',
            'StartLocation' => '\\StructType\\StartLocation',
            'EndLocation' => '\\StructType\\EndLocation',
            'WarningType' => '\\StructType\\WarningType',
            'WarningsType' => '\\StructType\\WarningsType',
            'WrittenConfInstType' => '\\StructType\\WrittenConfInstType',
            'AdvResTicketingType' => '\\StructType\\AdvResTicketingType',
            'AdvReservation' => '\\StructType\\AdvReservation',
            'AdvTicketing' => '\\StructType\\AdvTicketing',
            'AirFeeType' => '\\StructType\\AirFeeType',
            'AirItineraryPricingInfoType' => '\\StructType\\AirItineraryPricingInfoType',
            'PTC_FareBreakdowns' => '\\StructType\\PTC_FareBreakdowns',
            'FareInfos' => '\\StructType\\FareInfos',
            'FareInfo' => '\\StructType\\FareInfo',
            'AvailableFlexiFares' => '\\StructType\\AvailableFlexiFares',
            'AirItineraryType' => '\\StructType\\AirItineraryType',
            'OriginDestinationOptions' => '\\StructType\\OriginDestinationOptions',
            'AirReservationType' => '\\StructType\\AirReservationType',
            'Fulfillment' => '\\StructType\\Fulfillment',
            'PaymentDetails' => '\\StructType\\PaymentDetails',
            'Queues' => '\\StructType\\Queues',
            'Queue' => '\\StructType\\Queue',
            'AirTaxType' => '\\StructType\\AirTaxType',
            'AirTravelerType' => '\\StructType\\AirTravelerType',
            'ProfileRef' => '\\StructType\\ProfileRef',
            'Email' => '\\StructType\\Email',
            'Document' => '\\StructType\\Document',
            'TravelerRefNumber' => '\\StructType\\TravelerRefNumber',
            'FlightSegmentRPHs' => '\\StructType\\FlightSegmentRPHs',
            'ETicketInfo' => '\\StructType\\ETicketInfo',
            'BookFlightSegmentType' => '\\StructType\\BookFlightSegmentType',
            'BookingClassAvails' => '\\StructType\\BookingClassAvails',
            'BookingClassAvail' => '\\StructType\\BookingClassAvail',
            'AvailableFlexiOperations' => '\\StructType\\AvailableFlexiOperations',
            'BookingPriceInfoType' => '\\StructType\\BookingPriceInfoType',
            'CabinAvailabilityType' => '\\StructType\\CabinAvailabilityType',
            'Meal' => '\\StructType\\Meal',
            'BaggageAllowance' => '\\StructType\\BaggageAllowance',
            'CabinClassType' => '\\StructType\\CabinClassType',
            'AirRows' => '\\StructType\\AirRows',
            'FareInfoType' => '\\StructType\\FareInfoType',
            'FareReference' => '\\StructType\\FareReference',
            'RuleInfo' => '\\StructType\\RuleInfo',
            'Date' => '\\StructType\\Date',
            'Fare' => '\\StructType\\Fare',
            'PTC' => '\\StructType\\PTC',
            'FareType' => '\\StructType\\FareType',
            'BaseFare' => '\\StructType\\BaseFare',
            'EquivFare' => '\\StructType\\EquivFare',
            'Taxes' => '\\StructType\\Taxes',
            'Fees' => '\\StructType\\Fees',
            'TotalFare' => '\\StructType\\TotalFare',
            'TotalEquivFare' => '\\StructType\\TotalEquivFare',
            'TotalFareWithCCFee' => '\\StructType\\TotalFareWithCCFee',
            'TotalEquivFareWithCCFee' => '\\StructType\\TotalEquivFareWithCCFee',
            'FareConstruction' => '\\StructType\\FareConstruction',
            'UnstructuredFareCalc' => '\\StructType\\UnstructuredFareCalc',
            'FareTypePrefType' => '\\StructType\\FareTypePrefType',
            'FlightSegmentType' => '\\StructType\\FlightSegmentType',
            'MarketingAirline' => '\\StructType\\MarketingAirline',
            'MarketingCabinType' => '\\StructType\\MarketingCabinType',
            'OriginDestinationOptionType' => '\\StructType\\OriginDestinationOptionType',
            'OtherServiceInfoType' => '\\StructType\\OtherServiceInfoType',
            'PassengerTypeQuantityType' => '\\StructType\\PassengerTypeQuantityType',
            'PriceRequestInformationType' => '\\StructType\\PriceRequestInformationType',
            'NegotiatedFareCode' => '\\StructType\\NegotiatedFareCode',
            'PricedItinerariesType' => '\\StructType\\PricedItinerariesType',
            'PricedItineraryType' => '\\StructType\\PricedItineraryType',
            'PTCFareBreakdownType' => '\\StructType\\PTCFareBreakdownType',
            'FareBasisCodes' => '\\StructType\\FareBasisCodes',
            'TicketDesignators' => '\\StructType\\TicketDesignators',
            'TicketDesignator' => '\\StructType\\TicketDesignator',
            'Endorsements' => '\\StructType\\Endorsements',
            'Endorsement' => '\\StructType\\Endorsement',
            'FlexiFareType' => '\\StructType\\FlexiFareType',
            'FlexiFareAmount' => '\\StructType\\FlexiFareAmount',
            'AllowedFlexiOperations' => '\\StructType\\AllowedFlexiOperations',
            'PerPaxFlexifareBDS' => '\\StructType\\PerPaxFlexifareBDS',
            'PerPaxFlexifareBDType' => '\\StructType\\PerPaxFlexifareBDType',
            'PerPaxFlexiFareAmount' => '\\StructType\\PerPaxFlexiFareAmount',
            'FlexiOperationsType' => '\\StructType\\FlexiOperationsType',
            'RowDetailsType' => '\\StructType\\RowDetailsType',
            'AirSeats' => '\\StructType\\AirSeats',
            'AirSeat' => '\\StructType\\AirSeat',
            'AirRowCharacteristics' => '\\StructType\\AirRowCharacteristics',
            'RuleInfoType' => '\\StructType\\RuleInfoType',
            'ResTicketingRules' => '\\StructType\\ResTicketingRules',
            'AdvResTicketing' => '\\StructType\\AdvResTicketing',
            'ChargesRules' => '\\StructType\\ChargesRules',
            'SeatMapDetailsType' => '\\StructType\\SeatMapDetailsType',
            'SeatRequestType' => '\\StructType\\SeatRequestType',
            'MealRequestType' => '\\StructType\\MealRequestType',
            'SSRRequestType' => '\\StructType\\SSRRequestType',
            'BaggageRequestType' => '\\StructType\\BaggageRequestType',
            'InsuranceRequestType' => '\\StructType\\InsuranceRequestType',
            'SpecialRemarkType' => '\\StructType\\SpecialRemarkType',
            'FlightRefNumber' => '\\StructType\\FlightRefNumber',
            'AuthorizedViewers' => '\\StructType\\AuthorizedViewers',
            'AuthorizedViewer' => '\\StructType\\AuthorizedViewer',
            'SpecialReqDetailsType' => '\\StructType\\SpecialReqDetailsType',
            'SeatRequests' => '\\StructType\\SeatRequests',
            'SeatRequest' => '\\StructType\\SeatRequest',
            'SpecialServiceRequests' => '\\StructType\\SpecialServiceRequests',
            'SpecialServiceRequest' => '\\StructType\\SpecialServiceRequest',
            'MealRequests' => '\\StructType\\MealRequests',
            'MealRequest' => '\\StructType\\MealRequest',
            'SSRRequests' => '\\StructType\\SSRRequests',
            'SSRRequest' => '\\StructType\\SSRRequest',
            'BaggageRequests' => '\\StructType\\BaggageRequests',
            'BaggageRequest' => '\\StructType\\BaggageRequest',
            'InsuranceRequests' => '\\StructType\\InsuranceRequests',
            'InsuranceRequest' => '\\StructType\\InsuranceRequest',
            'OtherServiceInformations' => '\\StructType\\OtherServiceInformations',
            'OtherServiceInformation' => '\\StructType\\OtherServiceInformation',
            'Remarks' => '\\StructType\\Remarks',
            'Remark' => '\\StructType\\Remark',
            'SpecialRemarks' => '\\StructType\\SpecialRemarks',
            'SpecialRemark' => '\\StructType\\SpecialRemark',
            'SpecialServiceRequestType' => '\\StructType\\SpecialServiceRequestType',
            'SpecificFlightInfoType' => '\\StructType\\SpecificFlightInfoType',
            'BookingClassPref' => '\\StructType\\BookingClassPref',
            'StayRestrictionsType' => '\\StructType\\StayRestrictionsType',
            'MinimumStay' => '\\StructType\\MinimumStay',
            'MaximumStay' => '\\StructType\\MaximumStay',
            'TicketingInfoRS_Type' => '\\StructType\\TicketingInfoRS_Type',
            'TicketingInfoType' => '\\StructType\\TicketingInfoType',
            'TravelerInformationType' => '\\StructType\\TravelerInformationType',
            'TravelerInfoSummaryType' => '\\StructType\\TravelerInfoSummaryType',
            'TravelerInfoType' => '\\StructType\\TravelerInfoType',
            'VoluntaryChangesType' => '\\StructType\\VoluntaryChangesType',
            'Penalty' => '\\StructType\\Penalty',
            'EticketInfoType' => '\\StructType\\EticketInfoType',
            'Baggage' => '\\StructType\\Baggage',
            'AirportService' => '\\StructType\\AirportService',
            'InflightService' => '\\StructType\\InflightService',
            'TravelersFulfillments' => '\\StructType\\TravelersFulfillments',
            'TravelerFulfillments' => '\\StructType\\TravelerFulfillments',
            'AABundledServiceExt' => '\\StructType\\AABundledServiceExt',
            'BundledService' => '\\StructType\\BundledService',
            'StringStringMap' => '\\StructType\\StringStringMap',
            'OTA_PingRQ' => '\\StructType\\OTA_PingRQ',
            'OTA_PingRS' => '\\StructType\\OTA_PingRS',
            'AddressPrefType' => '\\StructType\\AddressPrefType',
            'CommonPrefType' => '\\StructType\\CommonPrefType',
            'CompanyNamePrefType' => '\\StructType\\CompanyNamePrefType',
            'InsurancePrefType' => '\\StructType\\InsurancePrefType',
            'InterestPrefType' => '\\StructType\\InterestPrefType',
            'LoyaltyPrefType' => '\\StructType\\LoyaltyPrefType',
            'MealPrefType' => '\\StructType\\MealPrefType',
            'MediaEntertainPrefType' => '\\StructType\\MediaEntertainPrefType',
            'NamePrefType' => '\\StructType\\NamePrefType',
            'OtherSrvcPrefType' => '\\StructType\\OtherSrvcPrefType',
            'PaymentFormPrefType' => '\\StructType\\PaymentFormPrefType',
            'PetInfoPrefType' => '\\StructType\\PetInfoPrefType',
            'PhonePrefType' => '\\StructType\\PhonePrefType',
            'RelatedTravelerPrefType' => '\\StructType\\RelatedTravelerPrefType',
            'SeatingPrefType' => '\\StructType\\SeatingPrefType',
            'SpecRequestPrefType' => '\\StructType\\SpecRequestPrefType',
            'TicketDistribPrefType' => '\\StructType\\TicketDistribPrefType',
            'AirlinePrefType' => '\\StructType\\AirlinePrefType',
            'FareRestrictPref' => '\\StructType\\FareRestrictPref',
            'FlightTypePref' => '\\StructType\\FlightTypePref',
            'CabinPref' => '\\StructType\\CabinPref',
            'SeatPref' => '\\StructType\\SeatPref',
            'SSR_Pref' => '\\StructType\\SSR_Pref',
            'AirportPrefType' => '\\StructType\\AirportPrefType',
            'AirSearchPrefsType' => '\\StructType\\AirSearchPrefsType',
            'TicketDistribPref' => '\\StructType\\TicketDistribPref',
            'EquipmentTypePref' => '\\StructType\\EquipmentTypePref',
            'OTA_AirAvailRQ' => '\\StructType\\OTA_AirAvailRQ',
            'ProcessingInfo' => '\\StructType\\ProcessingInfo',
            'OriginDestinationInformation' => '\\StructType\\OriginDestinationInformation',
            'ModifiedSegmentInfo' => '\\StructType\\ModifiedSegmentInfo',
            'OTA_AirAvailRS' => '\\StructType\\OTA_AirAvailRS',
            'OriginDestinationOption' => '\\StructType\\OriginDestinationOption',
            'FlightSegment' => '\\StructType\\FlightSegment',
            'AAAirAvailRSExt' => '\\StructType\\AAAirAvailRSExt',
            'OTA_AirPriceRQ' => '\\StructType\\OTA_AirPriceRQ',
            'FlexiFareSelectionOptions' => '\\StructType\\FlexiFareSelectionOptions',
            'BundledServiceSelectionOptions' => '\\StructType\\BundledServiceSelectionOptions',
            'OTA_AirPriceRS' => '\\StructType\\OTA_AirPriceRS',
            'OTA_AirBookRQ' => '\\StructType\\OTA_AirBookRQ',
            'PriceInfo' => '\\StructType\\PriceInfo',
            'Receipt' => '\\StructType\\Receipt',
            'OTA_AirBookRS' => '\\StructType\\OTA_AirBookRS',
            'AirReservation' => '\\StructType\\AirReservation',
            'OTA_AirBookModifyRQ' => '\\StructType\\OTA_AirBookModifyRQ',
            'AirBookModifyRQ' => '\\StructType\\AirBookModifyRQ',
            'OTA_ReadRQ' => '\\StructType\\OTA_ReadRQ',
            'ReadRequests' => '\\StructType\\ReadRequests',
            'ReadRequest' => '\\StructType\\ReadRequest',
            'GlobalReservationReadRequest' => '\\StructType\\GlobalReservationReadRequest',
            'AirReadRequest' => '\\StructType\\AirReadRequest',
            'QueueInfo' => '\\StructType\\QueueInfo',
            'OTA_ResRetrieveRS' => '\\StructType\\OTA_ResRetrieveRS',
            'ReservationsList' => '\\StructType\\ReservationsList',
            'GlobalReservation' => '\\StructType\\GlobalReservation',
            'OTA_AirScheduleRQ' => '\\StructType\\OTA_AirScheduleRQ',
            'OTA_AirScheduleRS' => '\\StructType\\OTA_AirScheduleRS',
            'OTA_AirFlifoRQ' => '\\StructType\\OTA_AirFlifoRQ',
            'OTA_AirFlifoRS' => '\\StructType\\OTA_AirFlifoRS',
            'FlightInfoDetails' => '\\StructType\\FlightInfoDetails',
            'FlightLegInfo' => '\\StructType\\FlightLegInfo',
            'Comment' => '\\StructType\\Comment',
            'DepartureDateTime' => '\\StructType\\DepartureDateTime',
            'ArrivalDateTime' => '\\StructType\\ArrivalDateTime',
            'OTA_AirSeatMapRQ' => '\\StructType\\OTA_AirSeatMapRQ',
            'SeatMapRequests' => '\\StructType\\SeatMapRequests',
            'SeatMapRequest' => '\\StructType\\SeatMapRequest',
            'SeatDetails' => '\\StructType\\SeatDetails',
            'CabinClass' => '\\StructType\\CabinClass',
            'ResBookDesignations' => '\\StructType\\ResBookDesignations',
            'ResBookDesignation' => '\\StructType\\ResBookDesignation',
            'AirTravelers' => '\\StructType\\AirTravelers',
            'AirTraveler' => '\\StructType\\AirTraveler',
            'OTA_AirSeatMapRS' => '\\StructType\\OTA_AirSeatMapRS',
            'SeatMapResponses' => '\\StructType\\SeatMapResponses',
            'SeatMapResponse' => '\\StructType\\SeatMapResponse',
            'FlightSegmentInfo' => '\\StructType\\FlightSegmentInfo',
            'CoverageLimitType' => '\\StructType\\CoverageLimitType',
            'Deductible' => '\\StructType\\Deductible',
            'PolicyLimit' => '\\StructType\\PolicyLimit',
            'IndividualLimit' => '\\StructType\\IndividualLimit',
            'CoveredTravelerType' => '\\StructType\\CoveredTravelerType',
            'CoveredPerson' => '\\StructType\\CoveredPerson',
            'Beneficiary' => '\\StructType\\Beneficiary',
            'DistribPrefType' => '\\StructType\\DistribPrefType',
            'IndCoverageReqsType' => '\\StructType\\IndCoverageReqsType',
            'IndTripCost' => '\\StructType\\IndTripCost',
            'FlightAccidentAmount' => '\\StructType\\FlightAccidentAmount',
            'CoveredLuggage' => '\\StructType\\CoveredLuggage',
            'LuggageItem' => '\\StructType\\LuggageItem',
            'ItemDeclaredValue' => '\\StructType\\ItemDeclaredValue',
            'LuggagePremium' => '\\StructType\\LuggagePremium',
            'PreexistingConditions' => '\\StructType\\PreexistingConditions',
            'PreexistingCondition' => '\\StructType\\PreexistingCondition',
            'InsCoverageDetailType' => '\\StructType\\InsCoverageDetailType',
            'TotalTripQuantity' => '\\StructType\\TotalTripQuantity',
            'TotalTripCost' => '\\StructType\\TotalTripCost',
            'CoveredTrips' => '\\StructType\\CoveredTrips',
            'CoveredTrip' => '\\StructType\\CoveredTrip',
            'InsCoverageType' => '\\StructType\\InsCoverageType',
            'CoveredTravelers' => '\\StructType\\CoveredTravelers',
            'InsuranceCustomerType' => '\\StructType\\InsuranceCustomerType',
            'PlanCostType' => '\\StructType\\PlanCostType',
            'BasePremium' => '\\StructType\\BasePremium',
            'Charges' => '\\StructType\\Charges',
            'PlanRestrictionType' => '\\StructType\\PlanRestrictionType',
            'PlanRestriction' => '\\StructType\\PlanRestriction',
            'RequestedCoveragesType' => '\\StructType\\RequestedCoveragesType',
            'SearchTravelerType' => '\\StructType\\SearchTravelerType',
            'TripFeaturesType' => '\\StructType\\TripFeaturesType',
            'Destinations' => '\\StructType\\Destinations',
            'Destination' => '\\StructType\\Destination',
            'Activities' => '\\StructType\\Activities',
            'Operators' => '\\StructType\\Operators',
            'OTA_InsuranceQuoteRQ' => '\\StructType\\OTA_InsuranceQuoteRQ',
            'PlanForQuoteRQ' => '\\StructType\\PlanForQuoteRQ',
            'OTA_InsuranceQuoteRS' => '\\StructType\\OTA_InsuranceQuoteRS',
            'PlanForQuoteRS' => '\\StructType\\PlanForQuoteRS',
            'QuoteDetail' => '\\StructType\\QuoteDetail',
            'AA_OTA_PaxCreditReadRQ' => '\\StructType\\AA_OTA_PaxCreditReadRQ',
            'AAPaxCreditReadRequestType' => '\\StructType\\AAPaxCreditReadRequestType',
            'FromAirport' => '\\StructType\\FromAirport',
            'ToAirport' => '\\StructType\\ToAirport',
            'AA_OTA_PaxCreditRS' => '\\StructType\\AA_OTA_PaxCreditRS',
            'AAPnrPaxCreditsType' => '\\StructType\\AAPnrPaxCreditsType',
            'AAPnrPaxCreditType' => '\\StructType\\AAPnrPaxCreditType',
            'AAPaxCreditType' => '\\StructType\\AAPaxCreditType',
            'CreditAmount' => '\\StructType\\CreditAmount',
            'AA_OTA_AgentAvailCreditRQ' => '\\StructType\\AA_OTA_AgentAvailCreditRQ',
            'AA_OTA_AgentAvailCreditRS' => '\\StructType\\AA_OTA_AgentAvailCreditRS',
            'AAAgentAvailCreditType' => '\\StructType\\AAAgentAvailCreditType',
            'AvailableCredit' => '\\StructType\\AvailableCredit',
            'AA_OTA_TransactionsReconRQ' => '\\StructType\\AA_OTA_TransactionsReconRQ',
            'AAPNRPaymentTransactionType' => '\\StructType\\AAPNRPaymentTransactionType',
            'PaymentTransaction' => '\\StructType\\PaymentTransaction',
            'AA_OTA_TermsNConditionsRQ' => '\\StructType\\AA_OTA_TermsNConditionsRQ',
            'AA_OTA_TermsNConditionsRS' => '\\StructType\\AA_OTA_TermsNConditionsRS',
            'AA_OTA_ResAuditReadRQ' => '\\StructType\\AA_OTA_ResAuditReadRQ',
            'AA_OTA_ResAuditRS' => '\\StructType\\AA_OTA_ResAuditRS',
            'AAPNRAuditMessagesType' => '\\StructType\\AAPNRAuditMessagesType',
            'AAPNRAuditMessageType' => '\\StructType\\AAPNRAuditMessageType',
            'AAAuditType' => '\\StructType\\AAAuditType',
            'AA_OTA_TransactionsReconRS' => '\\StructType\\AA_OTA_TransactionsReconRS',
            'AA_OTA_EBIPnrTxnsReconRQ' => '\\StructType\\AA_OTA_EBIPnrTxnsReconRQ',
            'AA_OTA_EBIManualDailyReconRptSendRQ' => '\\StructType\\AA_OTA_EBIManualDailyReconRptSendRQ',
            'AAReconRptCriteriaType' => '\\StructType\\AAReconRptCriteriaType',
            'AAReadRQExt' => '\\StructType\\AAReadRQExt',
            'AAAirReservationExt' => '\\StructType\\AAAirReservationExt',
            'AAAirBookRQExt' => '\\StructType\\AAAirBookRQExt',
            'AAAirBookModifyRQExt' => '\\StructType\\AAAirBookModifyRQExt',
            'AALoadDataOptionsType' => '\\StructType\\AALoadDataOptionsType',
            'AAResAccSummaryType' => '\\StructType\\AAResAccSummaryType',
            'AATravelersAccSummaryType' => '\\StructType\\AATravelersAccSummaryType',
            'AATravelerAccSummaryType' => '\\StructType\\AATravelerAccSummaryType',
            'AATravelerInfoType' => '\\StructType\\AATravelerInfoType',
            'AAAirTravelerType' => '\\StructType\\AAAirTravelerType',
            'AAUserNotesType' => '\\StructType\\AAUserNotesType',
            'AAUserNoteType' => '\\StructType\\AAUserNoteType',
            'AAContactInfoType' => '\\StructType\\AAContactInfoType',
            'AAAdminInfoType' => '\\StructType\\AAAdminInfoType',
            'AABookingCategoryType' => '\\StructType\\AABookingCategoryType',
            'AAResSummaryType' => '\\StructType\\AAResSummaryType',
            'AAPTCCountsType' => '\\StructType\\AAPTCCountsType',
            'AAPTCCountType' => '\\StructType\\AAPTCCountType',
            'AAPersonNameType' => '\\StructType\\AAPersonNameType',
            'AATelephoneType' => '\\StructType\\AATelephoneType',
            'AAAddressType' => '\\StructType\\AAAddressType',
            'AACountryType' => '\\StructType\\AACountryType',
            'AAEmergencyContactType' => '\\StructType\\AAEmergencyContactType',
            'AAAlterationBalancesType' => '\\StructType\\AAAlterationBalancesType',
            'AAModONDBalances' => '\\StructType\\AAModONDBalances',
            'AACnxModAddONDBalancesType' => '\\StructType\\AACnxModAddONDBalancesType',
            'AATravelersCnxModAddResBalancesType' => '\\StructType\\AATravelersCnxModAddResBalancesType',
            'AATravelerCnxModAddResBalancesType' => '\\StructType\\AATravelerCnxModAddResBalancesType',
            'AAExternalPayTxesType' => '\\StructType\\AAExternalPayTxesType',
            'AAExternalPayTxType' => '\\StructType\\AAExternalPayTxType',
            'AAPropertiesType' => '\\StructType\\AAPropertiesType',
            'AAPropertyType' => '\\StructType\\AAPropertyType',
            'AACurrencyAmountType' => '\\StructType\\AACurrencyAmountType',
            'AAStatusErrorsAndWarnings' => '\\StructType\\AAStatusErrorsAndWarnings',
            'PFSPax' => '\\StructType\\PFSPax',
            'PFSFlight' => '\\StructType\\PFSFlight',
            'AAFlightInventryBatchUpdateRQ' => '\\StructType\\AAFlightInventryBatchUpdateRQ',
            'AAFlightInvUpdateRQType' => '\\StructType\\AAFlightInvUpdateRQType',
            'AAFlightInvUpdateRQ' => '\\StructType\\AAFlightInvUpdateRQ',
            'AAFCCSegBCInventoryAddType' => '\\StructType\\AAFCCSegBCInventoryAddType',
            'AAFCCSegBCInventoryUpdateType' => '\\StructType\\AAFCCSegBCInventoryUpdateType',
            'AAFCCSegBCInventoryDeleteType' => '\\StructType\\AAFCCSegBCInventoryDeleteType',
            'AAFCCSegBCInventoryDelete' => '\\StructType\\AAFCCSegBCInventoryDelete',
            'AAFCCSegBCInventoryAdd' => '\\StructType\\AAFCCSegBCInventoryAdd',
            'AAFCCSegBCInventoryUpdate' => '\\StructType\\AAFCCSegBCInventoryUpdate',
            'AAFlightInvBatchUpdateRS' => '\\StructType\\AAFlightInvBatchUpdateRS',
            'AAFlightInvRSType' => '\\StructType\\AAFlightInvRSType',
            'AAFlightInvRS' => '\\StructType\\AAFlightInvRS',
            'AAUpdateOptimizedInventoryRQ' => '\\StructType\\AAUpdateOptimizedInventoryRQ',
            'AAUpdateOptimizedInventoryRS' => '\\StructType\\AAUpdateOptimizedInventoryRS',
            'AAInventorySeatMovementsType' => '\\StructType\\AAInventorySeatMovementsType',
            'AAInventorySeatMovementType' => '\\StructType\\AAInventorySeatMovementType',
            'AAAgentSeatMovemantRQ' => '\\StructType\\AAAgentSeatMovemantRQ',
            'AAAgentSeatMovemantRS' => '\\StructType\\AAAgentSeatMovemantRS',
            'AAAgentSeatMovementsType' => '\\StructType\\AAAgentSeatMovementsType',
            'AAAgentSeatMovementType' => '\\StructType\\AAAgentSeatMovementType',
            'AAFlightInventorySearchRQ' => '\\StructType\\AAFlightInventorySearchRQ',
            'AAFlightInventoryDataRS' => '\\StructType\\AAFlightInventoryDataRS',
            'AASegmentSeatInventoriesType' => '\\StructType\\AASegmentSeatInventoriesType',
            'AASeatBCAllocationsType' => '\\StructType\\AASeatBCAllocationsType',
            'AAFareType' => '\\StructType\\AAFareType',
            'AAFligthtLegPaxCountInfoRQ' => '\\StructType\\AAFligthtLegPaxCountInfoRQ',
            'AAFligthtLegPaxCountInfoRS' => '\\StructType\\AAFligthtLegPaxCountInfoRS',
            'AAPaxTypeCountSummaryType' => '\\StructType\\AAPaxTypeCountSummaryType',
            'AAPaxTypeCountDetailType' => '\\StructType\\AAPaxTypeCountDetailType',
            'AAIOBoundPaxCountInfoRS' => '\\StructType\\AAIOBoundPaxCountInfoRS',
            'AAAirportSummaryType' => '\\StructType\\AAAirportSummaryType',
            'AAFlightLoadInfoRQ' => '\\StructType\\AAFlightLoadInfoRQ',
            'AAFlightLoadInfoRS' => '\\StructType\\AAFlightLoadInfoRS',
            'AAFlightLoadInfo' => '\\StructType\\AAFlightLoadInfo',
            'AACabinInventoryType' => '\\StructType\\AACabinInventoryType',
            'AASegmentInventoryType' => '\\StructType\\AASegmentInventoryType',
            'AAResultType' => '\\StructType\\AAResultType',
            'AA_OTA_ItineraryRS' => '\\StructType\\AA_OTA_ItineraryRS',
            'AAPNRPaxTicketingDataRQ' => '\\StructType\\AAPNRPaxTicketingDataRQ',
            'AAPNRPaxTicketingDataRS' => '\\StructType\\AAPNRPaxTicketingDataRS',
            'AAPNRPaxesTicketingDataType' => '\\StructType\\AAPNRPaxesTicketingDataType',
            'AAPNRPaxTicketingDataType' => '\\StructType\\AAPNRPaxTicketingDataType',
            'pax' => '\\StructType\\Pax',
            'AAPNRFlightSegmentsType' => '\\StructType\\AAPNRFlightSegmentsType',
            'AAPNRPaxTransactionsType' => '\\StructType\\AAPNRPaxTransactionsType',
            'AAPNRPaxSegsPricingType' => '\\StructType\\AAPNRPaxSegsPricingType',
            'AAPNRPaxTransactionType' => '\\StructType\\AAPNRPaxTransactionType',
            'amountInBaseCurrency' => '\\StructType\\AmountInBaseCurrency',
            'amountInPayCurrency' => '\\StructType\\AmountInPayCurrency',
            'AAPNRPaxSegPricingType' => '\\StructType\\AAPNRPaxSegPricingType',
            'fare' => '\\StructType\\Fare_1',
            'AAFeesType' => '\\StructType\\AAFeesType',
            'AATaxesType' => '\\StructType\\AATaxesType',
            'AATaxType' => '\\StructType\\AATaxType',
            'AAFeeType' => '\\StructType\\AAFeeType',
            'AAPNRFlightSegmentType' => '\\StructType\\AAPNRFlightSegmentType',
            'AA_OTA_AirMealDetailsRQ' => '\\StructType\\AA_OTA_AirMealDetailsRQ',
            'MealDetailsRequests' => '\\StructType\\MealDetailsRequests',
            'MealDetailsRequest' => '\\StructType\\MealDetailsRequest',
            'MealDetails' => '\\StructType\\MealDetails',
            'AA_OTA_AirMealDetailsRS' => '\\StructType\\AA_OTA_AirMealDetailsRS',
            'MealDetailsResponses' => '\\StructType\\MealDetailsResponses',
            'MealDetailsResponse' => '\\StructType\\MealDetailsResponse',
            'AA_OTA_AirSSRDetailsRQ' => '\\StructType\\AA_OTA_AirSSRDetailsRQ',
            'SSRDetailsRequests' => '\\StructType\\SSRDetailsRequests',
            'SSRDetailsRequest' => '\\StructType\\SSRDetailsRequest',
            'SSRDetails' => '\\StructType\\SSRDetails',
            'AA_OTA_AirSSRDetailsRS' => '\\StructType\\AA_OTA_AirSSRDetailsRS',
            'SSRDetailsResponses' => '\\StructType\\SSRDetailsResponses',
            'SSRDetailsResponse' => '\\StructType\\SSRDetailsResponse',
            'AA_OTA_AirBaggageDetailsRQ' => '\\StructType\\AA_OTA_AirBaggageDetailsRQ',
            'BaggageDetailsRequests' => '\\StructType\\BaggageDetailsRequests',
            'BaggageDetailsRequest' => '\\StructType\\BaggageDetailsRequest',
            'BaggageDetails' => '\\StructType\\BaggageDetails',
            'AA_OTA_AirBaggageDetailsRS' => '\\StructType\\AA_OTA_AirBaggageDetailsRS',
            'BaggageDetailsResponses' => '\\StructType\\BaggageDetailsResponses',
            'BaggageDetailsResponse' => '\\StructType\\BaggageDetailsResponse',
            'OnDBaggageDetailsResponse' => '\\StructType\\OnDBaggageDetailsResponse',
            'OnDFlightSegmentInfo' => '\\StructType\\OnDFlightSegmentInfo',
            'AA_OTA_ETicketStatusUpdateRQ' => '\\StructType\\AA_OTA_ETicketStatusUpdateRQ',
            'AA_OTA_ETicketStatusUpdateRS' => '\\StructType\\AA_OTA_ETicketStatusUpdateRS',
            'AA_OTA_PFSUpdateRQ' => '\\StructType\\AA_OTA_PFSUpdateRQ',
            'AA_OTA_PFSUpdateRS' => '\\StructType\\AA_OTA_PFSUpdateRS',
        );
    }
}
