<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Sync ServiceType
 * @subpackage Services
 */
class Sync extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named syncPnrTxnsWithEBI
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\AA_OTA_EBIPnrTxnsReconRQ $aA_OTA_EBIPnrTxnsReconRQ
     * @return void|bool
     */
    public function syncPnrTxnsWithEBI(\StructType\AA_OTA_EBIPnrTxnsReconRQ $aA_OTA_EBIPnrTxnsReconRQ)
    {
        try {
            $this->setResult(self::getSoapClient()->syncPnrTxnsWithEBI($aA_OTA_EBIPnrTxnsReconRQ));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return void
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
