<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AAExternalPayTxesType StructType
 * Meta informations extracted from the WSDL
 * - documentation: External payment trasactions information
 * @subpackage Structs
 */
class AAExternalPayTxesType extends AbstractStructBase
{
    /**
     * The ExtPayTxes
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\AAExternalPayTxType[]
     */
    public $ExtPayTxes;
    /**
     * Constructor method for AAExternalPayTxesType
     * @uses AAExternalPayTxesType::setExtPayTxes()
     * @param \StructType\AAExternalPayTxType[] $extPayTxes
     */
    public function __construct(array $extPayTxes = array())
    {
        $this
            ->setExtPayTxes($extPayTxes);
    }
    /**
     * Get ExtPayTxes value
     * @return \StructType\AAExternalPayTxType[]|null
     */
    public function getExtPayTxes()
    {
        return $this->ExtPayTxes;
    }
    /**
     * Set ExtPayTxes value
     * @throws \InvalidArgumentException
     * @param \StructType\AAExternalPayTxType[] $extPayTxes
     * @return \StructType\AAExternalPayTxesType
     */
    public function setExtPayTxes(array $extPayTxes = array())
    {
        foreach ($extPayTxes as $aAExternalPayTxesTypeExtPayTxesItem) {
            // validation for constraint: itemType
            if (!$aAExternalPayTxesTypeExtPayTxesItem instanceof \StructType\AAExternalPayTxType) {
                throw new \InvalidArgumentException(sprintf('The ExtPayTxes property can only contain items of \StructType\AAExternalPayTxType, "%s" given', is_object($aAExternalPayTxesTypeExtPayTxesItem) ? get_class($aAExternalPayTxesTypeExtPayTxesItem) : gettype($aAExternalPayTxesTypeExtPayTxesItem)), __LINE__);
            }
        }
        $this->ExtPayTxes = $extPayTxes;
        return $this;
    }
    /**
     * Add item to ExtPayTxes value
     * @throws \InvalidArgumentException
     * @param \StructType\AAExternalPayTxType $item
     * @return \StructType\AAExternalPayTxesType
     */
    public function addToExtPayTxes(\StructType\AAExternalPayTxType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AAExternalPayTxType) {
            throw new \InvalidArgumentException(sprintf('The ExtPayTxes property can only contain items of \StructType\AAExternalPayTxType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ExtPayTxes[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AAExternalPayTxesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
