<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AAFCCSegBCInventoryDelete StructType
 * @subpackage Structs
 */
class AAFCCSegBCInventoryDelete extends AbstractStructBase
{
    /**
     * The bookingCode
     * @var string
     */
    public $bookingCode;
    /**
     * The adultFareAmount
     * @var float
     */
    public $adultFareAmount;
    /**
     * The fareType
     * @var string
     */
    public $fareType;
    /**
     * Constructor method for AAFCCSegBCInventoryDelete
     * @uses AAFCCSegBCInventoryDelete::setBookingCode()
     * @uses AAFCCSegBCInventoryDelete::setAdultFareAmount()
     * @uses AAFCCSegBCInventoryDelete::setFareType()
     * @param string $bookingCode
     * @param float $adultFareAmount
     * @param string $fareType
     */
    public function __construct($bookingCode = null, $adultFareAmount = null, $fareType = null)
    {
        $this
            ->setBookingCode($bookingCode)
            ->setAdultFareAmount($adultFareAmount)
            ->setFareType($fareType);
    }
    /**
     * Get bookingCode value
     * @return string|null
     */
    public function getBookingCode()
    {
        return $this->bookingCode;
    }
    /**
     * Set bookingCode value
     * @param string $bookingCode
     * @return \StructType\AAFCCSegBCInventoryDelete
     */
    public function setBookingCode($bookingCode = null)
    {
        // validation for constraint: string
        if (!is_null($bookingCode) && !is_string($bookingCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($bookingCode)), __LINE__);
        }
        $this->bookingCode = $bookingCode;
        return $this;
    }
    /**
     * Get adultFareAmount value
     * @return float|null
     */
    public function getAdultFareAmount()
    {
        return $this->adultFareAmount;
    }
    /**
     * Set adultFareAmount value
     * @param float $adultFareAmount
     * @return \StructType\AAFCCSegBCInventoryDelete
     */
    public function setAdultFareAmount($adultFareAmount = null)
    {
        $this->adultFareAmount = $adultFareAmount;
        return $this;
    }
    /**
     * Get fareType value
     * @return string|null
     */
    public function getFareType()
    {
        return $this->fareType;
    }
    /**
     * Set fareType value
     * @param string $fareType
     * @return \StructType\AAFCCSegBCInventoryDelete
     */
    public function setFareType($fareType = null)
    {
        // validation for constraint: string
        if (!is_null($fareType) && !is_string($fareType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fareType)), __LINE__);
        }
        $this->fareType = $fareType;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AAFCCSegBCInventoryDelete
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
