<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AAFeesType StructType
 * @subpackage Structs
 */
class AAFeesType extends AbstractStructBase
{
    /**
     * The fee
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\AAFeeType[]
     */
    public $fee;
    /**
     * Constructor method for AAFeesType
     * @uses AAFeesType::setFee()
     * @param \StructType\AAFeeType[] $fee
     */
    public function __construct(array $fee = array())
    {
        $this
            ->setFee($fee);
    }
    /**
     * Get fee value
     * @return \StructType\AAFeeType[]|null
     */
    public function getFee()
    {
        return $this->fee;
    }
    /**
     * Set fee value
     * @throws \InvalidArgumentException
     * @param \StructType\AAFeeType[] $fee
     * @return \StructType\AAFeesType
     */
    public function setFee(array $fee = array())
    {
        foreach ($fee as $aAFeesTypeFeeItem) {
            // validation for constraint: itemType
            if (!$aAFeesTypeFeeItem instanceof \StructType\AAFeeType) {
                throw new \InvalidArgumentException(sprintf('The fee property can only contain items of \StructType\AAFeeType, "%s" given', is_object($aAFeesTypeFeeItem) ? get_class($aAFeesTypeFeeItem) : gettype($aAFeesTypeFeeItem)), __LINE__);
            }
        }
        $this->fee = $fee;
        return $this;
    }
    /**
     * Add item to fee value
     * @throws \InvalidArgumentException
     * @param \StructType\AAFeeType $item
     * @return \StructType\AAFeesType
     */
    public function addToFee(\StructType\AAFeeType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AAFeeType) {
            throw new \InvalidArgumentException(sprintf('The fee property can only contain items of \StructType\AAFeeType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->fee[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AAFeesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
