<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AALoadDataOptionsType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Items to load in the AirBookRS
 * @subpackage Structs
 */
class AALoadDataOptionsType extends AbstractStructBase
{
    /**
     * The LoadTravelerInfo
     * Meta informations extracted from the WSDL
     * - default: true
     * - minOccurs: 0
     * @var bool
     */
    public $LoadTravelerInfo;
    /**
     * The LoadAirItinery
     * Meta informations extracted from the WSDL
     * - default: true
     * - minOccurs: 0
     * @var bool
     */
    public $LoadAirItinery;
    /**
     * The LoadPriceInfoTotals
     * Meta informations extracted from the WSDL
     * - default: true
     * - minOccurs: 0
     * @var bool
     */
    public $LoadPriceInfoTotals;
    /**
     * The LoadPTCPriceInfo
     * Meta informations extracted from the WSDL
     * - default: false
     * - minOccurs: 0
     * @var bool
     */
    public $LoadPTCPriceInfo;
    /**
     * The LoadFullFilment
     * Meta informations extracted from the WSDL
     * - default: false
     * - minOccurs: 0
     * @var bool
     */
    public $LoadFullFilment;
    /**
     * The LoadPTCFullFilment
     * Meta informations extracted from the WSDL
     * - default: false
     * - minOccurs: 0
     * @var bool
     */
    public $LoadPTCFullFilment;
    /**
     * The LoadAccSummary
     * Meta informations extracted from the WSDL
     * - default: false
     * - minOccurs: 0
     * @var bool
     */
    public $LoadAccSummary;
    /**
     * The LoadPTCAccSummary
     * Meta informations extracted from the WSDL
     * - default: false
     * - minOccurs: 0
     * @var bool
     */
    public $LoadPTCAccSummary;
    /**
     * Constructor method for AALoadDataOptionsType
     * @uses AALoadDataOptionsType::setLoadTravelerInfo()
     * @uses AALoadDataOptionsType::setLoadAirItinery()
     * @uses AALoadDataOptionsType::setLoadPriceInfoTotals()
     * @uses AALoadDataOptionsType::setLoadPTCPriceInfo()
     * @uses AALoadDataOptionsType::setLoadFullFilment()
     * @uses AALoadDataOptionsType::setLoadPTCFullFilment()
     * @uses AALoadDataOptionsType::setLoadAccSummary()
     * @uses AALoadDataOptionsType::setLoadPTCAccSummary()
     * @param bool $loadTravelerInfo
     * @param bool $loadAirItinery
     * @param bool $loadPriceInfoTotals
     * @param bool $loadPTCPriceInfo
     * @param bool $loadFullFilment
     * @param bool $loadPTCFullFilment
     * @param bool $loadAccSummary
     * @param bool $loadPTCAccSummary
     */
    public function __construct($loadTravelerInfo = true, $loadAirItinery = true, $loadPriceInfoTotals = true, $loadPTCPriceInfo = false, $loadFullFilment = false, $loadPTCFullFilment = false, $loadAccSummary = false, $loadPTCAccSummary = false)
    {
        $this
            ->setLoadTravelerInfo($loadTravelerInfo)
            ->setLoadAirItinery($loadAirItinery)
            ->setLoadPriceInfoTotals($loadPriceInfoTotals)
            ->setLoadPTCPriceInfo($loadPTCPriceInfo)
            ->setLoadFullFilment($loadFullFilment)
            ->setLoadPTCFullFilment($loadPTCFullFilment)
            ->setLoadAccSummary($loadAccSummary)
            ->setLoadPTCAccSummary($loadPTCAccSummary);
    }
    /**
     * Get LoadTravelerInfo value
     * @return bool|null
     */
    public function getLoadTravelerInfo()
    {
        return $this->LoadTravelerInfo;
    }
    /**
     * Set LoadTravelerInfo value
     * @param bool $loadTravelerInfo
     * @return \StructType\AALoadDataOptionsType
     */
    public function setLoadTravelerInfo($loadTravelerInfo = true)
    {
        // validation for constraint: boolean
        if (!is_null($loadTravelerInfo) && !is_bool($loadTravelerInfo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($loadTravelerInfo)), __LINE__);
        }
        $this->LoadTravelerInfo = $loadTravelerInfo;
        return $this;
    }
    /**
     * Get LoadAirItinery value
     * @return bool|null
     */
    public function getLoadAirItinery()
    {
        return $this->LoadAirItinery;
    }
    /**
     * Set LoadAirItinery value
     * @param bool $loadAirItinery
     * @return \StructType\AALoadDataOptionsType
     */
    public function setLoadAirItinery($loadAirItinery = true)
    {
        // validation for constraint: boolean
        if (!is_null($loadAirItinery) && !is_bool($loadAirItinery)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($loadAirItinery)), __LINE__);
        }
        $this->LoadAirItinery = $loadAirItinery;
        return $this;
    }
    /**
     * Get LoadPriceInfoTotals value
     * @return bool|null
     */
    public function getLoadPriceInfoTotals()
    {
        return $this->LoadPriceInfoTotals;
    }
    /**
     * Set LoadPriceInfoTotals value
     * @param bool $loadPriceInfoTotals
     * @return \StructType\AALoadDataOptionsType
     */
    public function setLoadPriceInfoTotals($loadPriceInfoTotals = true)
    {
        // validation for constraint: boolean
        if (!is_null($loadPriceInfoTotals) && !is_bool($loadPriceInfoTotals)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($loadPriceInfoTotals)), __LINE__);
        }
        $this->LoadPriceInfoTotals = $loadPriceInfoTotals;
        return $this;
    }
    /**
     * Get LoadPTCPriceInfo value
     * @return bool|null
     */
    public function getLoadPTCPriceInfo()
    {
        return $this->LoadPTCPriceInfo;
    }
    /**
     * Set LoadPTCPriceInfo value
     * @param bool $loadPTCPriceInfo
     * @return \StructType\AALoadDataOptionsType
     */
    public function setLoadPTCPriceInfo($loadPTCPriceInfo = false)
    {
        // validation for constraint: boolean
        if (!is_null($loadPTCPriceInfo) && !is_bool($loadPTCPriceInfo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($loadPTCPriceInfo)), __LINE__);
        }
        $this->LoadPTCPriceInfo = $loadPTCPriceInfo;
        return $this;
    }
    /**
     * Get LoadFullFilment value
     * @return bool|null
     */
    public function getLoadFullFilment()
    {
        return $this->LoadFullFilment;
    }
    /**
     * Set LoadFullFilment value
     * @param bool $loadFullFilment
     * @return \StructType\AALoadDataOptionsType
     */
    public function setLoadFullFilment($loadFullFilment = false)
    {
        // validation for constraint: boolean
        if (!is_null($loadFullFilment) && !is_bool($loadFullFilment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($loadFullFilment)), __LINE__);
        }
        $this->LoadFullFilment = $loadFullFilment;
        return $this;
    }
    /**
     * Get LoadPTCFullFilment value
     * @return bool|null
     */
    public function getLoadPTCFullFilment()
    {
        return $this->LoadPTCFullFilment;
    }
    /**
     * Set LoadPTCFullFilment value
     * @param bool $loadPTCFullFilment
     * @return \StructType\AALoadDataOptionsType
     */
    public function setLoadPTCFullFilment($loadPTCFullFilment = false)
    {
        // validation for constraint: boolean
        if (!is_null($loadPTCFullFilment) && !is_bool($loadPTCFullFilment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($loadPTCFullFilment)), __LINE__);
        }
        $this->LoadPTCFullFilment = $loadPTCFullFilment;
        return $this;
    }
    /**
     * Get LoadAccSummary value
     * @return bool|null
     */
    public function getLoadAccSummary()
    {
        return $this->LoadAccSummary;
    }
    /**
     * Set LoadAccSummary value
     * @param bool $loadAccSummary
     * @return \StructType\AALoadDataOptionsType
     */
    public function setLoadAccSummary($loadAccSummary = false)
    {
        // validation for constraint: boolean
        if (!is_null($loadAccSummary) && !is_bool($loadAccSummary)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($loadAccSummary)), __LINE__);
        }
        $this->LoadAccSummary = $loadAccSummary;
        return $this;
    }
    /**
     * Get LoadPTCAccSummary value
     * @return bool|null
     */
    public function getLoadPTCAccSummary()
    {
        return $this->LoadPTCAccSummary;
    }
    /**
     * Set LoadPTCAccSummary value
     * @param bool $loadPTCAccSummary
     * @return \StructType\AALoadDataOptionsType
     */
    public function setLoadPTCAccSummary($loadPTCAccSummary = false)
    {
        // validation for constraint: boolean
        if (!is_null($loadPTCAccSummary) && !is_bool($loadPTCAccSummary)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($loadPTCAccSummary)), __LINE__);
        }
        $this->LoadPTCAccSummary = $loadPTCAccSummary;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AALoadDataOptionsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
