<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AAModONDBalances StructType
 * Meta informations extracted from the WSDL
 * - documentation: Balances for OND being modified. | Pricing info summary on ONDs for modification process(charges and refundable/non-refundable amounts).
 * @subpackage Structs
 */
class AAModONDBalances extends AbstractStructBase
{
    /**
     * The UpdatingONDCharges
     * @var \StructType\AACnxModAddONDBalancesType
     */
    public $UpdatingONDCharges;
    /**
     * The NewONDCharges
     * @var \StructType\AACnxModAddONDBalancesType
     */
    public $NewONDCharges;
    /**
     * Constructor method for AAModONDBalances
     * @uses AAModONDBalances::setUpdatingONDCharges()
     * @uses AAModONDBalances::setNewONDCharges()
     * @param \StructType\AACnxModAddONDBalancesType $updatingONDCharges
     * @param \StructType\AACnxModAddONDBalancesType $newONDCharges
     */
    public function __construct(\StructType\AACnxModAddONDBalancesType $updatingONDCharges = null, \StructType\AACnxModAddONDBalancesType $newONDCharges = null)
    {
        $this
            ->setUpdatingONDCharges($updatingONDCharges)
            ->setNewONDCharges($newONDCharges);
    }
    /**
     * Get UpdatingONDCharges value
     * @return \StructType\AACnxModAddONDBalancesType|null
     */
    public function getUpdatingONDCharges()
    {
        return $this->UpdatingONDCharges;
    }
    /**
     * Set UpdatingONDCharges value
     * @param \StructType\AACnxModAddONDBalancesType $updatingONDCharges
     * @return \StructType\AAModONDBalances
     */
    public function setUpdatingONDCharges(\StructType\AACnxModAddONDBalancesType $updatingONDCharges = null)
    {
        $this->UpdatingONDCharges = $updatingONDCharges;
        return $this;
    }
    /**
     * Get NewONDCharges value
     * @return \StructType\AACnxModAddONDBalancesType|null
     */
    public function getNewONDCharges()
    {
        return $this->NewONDCharges;
    }
    /**
     * Set NewONDCharges value
     * @param \StructType\AACnxModAddONDBalancesType $newONDCharges
     * @return \StructType\AAModONDBalances
     */
    public function setNewONDCharges(\StructType\AACnxModAddONDBalancesType $newONDCharges = null)
    {
        $this->NewONDCharges = $newONDCharges;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AAModONDBalances
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
