<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AAPNRFlightSegmentsType StructType
 * @subpackage Structs
 */
class AAPNRFlightSegmentsType extends AbstractStructBase
{
    /**
     * The pnrFlightSegment
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\AAPNRFlightSegmentType[]
     */
    public $pnrFlightSegment;
    /**
     * Constructor method for AAPNRFlightSegmentsType
     * @uses AAPNRFlightSegmentsType::setPnrFlightSegment()
     * @param \StructType\AAPNRFlightSegmentType[] $pnrFlightSegment
     */
    public function __construct(array $pnrFlightSegment = array())
    {
        $this
            ->setPnrFlightSegment($pnrFlightSegment);
    }
    /**
     * Get pnrFlightSegment value
     * @return \StructType\AAPNRFlightSegmentType[]|null
     */
    public function getPnrFlightSegment()
    {
        return $this->pnrFlightSegment;
    }
    /**
     * Set pnrFlightSegment value
     * @throws \InvalidArgumentException
     * @param \StructType\AAPNRFlightSegmentType[] $pnrFlightSegment
     * @return \StructType\AAPNRFlightSegmentsType
     */
    public function setPnrFlightSegment(array $pnrFlightSegment = array())
    {
        foreach ($pnrFlightSegment as $aAPNRFlightSegmentsTypePnrFlightSegmentItem) {
            // validation for constraint: itemType
            if (!$aAPNRFlightSegmentsTypePnrFlightSegmentItem instanceof \StructType\AAPNRFlightSegmentType) {
                throw new \InvalidArgumentException(sprintf('The pnrFlightSegment property can only contain items of \StructType\AAPNRFlightSegmentType, "%s" given', is_object($aAPNRFlightSegmentsTypePnrFlightSegmentItem) ? get_class($aAPNRFlightSegmentsTypePnrFlightSegmentItem) : gettype($aAPNRFlightSegmentsTypePnrFlightSegmentItem)), __LINE__);
            }
        }
        $this->pnrFlightSegment = $pnrFlightSegment;
        return $this;
    }
    /**
     * Add item to pnrFlightSegment value
     * @throws \InvalidArgumentException
     * @param \StructType\AAPNRFlightSegmentType $item
     * @return \StructType\AAPNRFlightSegmentsType
     */
    public function addToPnrFlightSegment(\StructType\AAPNRFlightSegmentType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AAPNRFlightSegmentType) {
            throw new \InvalidArgumentException(sprintf('The pnrFlightSegment property can only contain items of \StructType\AAPNRFlightSegmentType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->pnrFlightSegment[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AAPNRFlightSegmentsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
