<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AAPNRPaxesTicketingDataType StructType
 * @subpackage Structs
 */
class AAPNRPaxesTicketingDataType extends AbstractStructBase
{
    /**
     * The pnrPaxTicketingData
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\AAPNRPaxTicketingDataType[]
     */
    public $pnrPaxTicketingData;
    /**
     * Constructor method for AAPNRPaxesTicketingDataType
     * @uses AAPNRPaxesTicketingDataType::setPnrPaxTicketingData()
     * @param \StructType\AAPNRPaxTicketingDataType[] $pnrPaxTicketingData
     */
    public function __construct(array $pnrPaxTicketingData = array())
    {
        $this
            ->setPnrPaxTicketingData($pnrPaxTicketingData);
    }
    /**
     * Get pnrPaxTicketingData value
     * @return \StructType\AAPNRPaxTicketingDataType[]|null
     */
    public function getPnrPaxTicketingData()
    {
        return $this->pnrPaxTicketingData;
    }
    /**
     * Set pnrPaxTicketingData value
     * @throws \InvalidArgumentException
     * @param \StructType\AAPNRPaxTicketingDataType[] $pnrPaxTicketingData
     * @return \StructType\AAPNRPaxesTicketingDataType
     */
    public function setPnrPaxTicketingData(array $pnrPaxTicketingData = array())
    {
        foreach ($pnrPaxTicketingData as $aAPNRPaxesTicketingDataTypePnrPaxTicketingDataItem) {
            // validation for constraint: itemType
            if (!$aAPNRPaxesTicketingDataTypePnrPaxTicketingDataItem instanceof \StructType\AAPNRPaxTicketingDataType) {
                throw new \InvalidArgumentException(sprintf('The pnrPaxTicketingData property can only contain items of \StructType\AAPNRPaxTicketingDataType, "%s" given', is_object($aAPNRPaxesTicketingDataTypePnrPaxTicketingDataItem) ? get_class($aAPNRPaxesTicketingDataTypePnrPaxTicketingDataItem) : gettype($aAPNRPaxesTicketingDataTypePnrPaxTicketingDataItem)), __LINE__);
            }
        }
        $this->pnrPaxTicketingData = $pnrPaxTicketingData;
        return $this;
    }
    /**
     * Add item to pnrPaxTicketingData value
     * @throws \InvalidArgumentException
     * @param \StructType\AAPNRPaxTicketingDataType $item
     * @return \StructType\AAPNRPaxesTicketingDataType
     */
    public function addToPnrPaxTicketingData(\StructType\AAPNRPaxTicketingDataType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AAPNRPaxTicketingDataType) {
            throw new \InvalidArgumentException(sprintf('The pnrPaxTicketingData property can only contain items of \StructType\AAPNRPaxTicketingDataType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->pnrPaxTicketingData[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AAPNRPaxesTicketingDataType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
