<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AAPnrPaxCreditsType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Collection of pnr pax credit details.
 * @subpackage Structs
 */
class AAPnrPaxCreditsType extends AbstractStructBase
{
    /**
     * The PnrPaxCredit
     * Meta informations extracted from the WSDL
     * - maxOccurs: 99
     * @var \StructType\AAPnrPaxCreditType[]
     */
    public $PnrPaxCredit;
    /**
     * Constructor method for AAPnrPaxCreditsType
     * @uses AAPnrPaxCreditsType::setPnrPaxCredit()
     * @param \StructType\AAPnrPaxCreditType[] $pnrPaxCredit
     */
    public function __construct(array $pnrPaxCredit = array())
    {
        $this
            ->setPnrPaxCredit($pnrPaxCredit);
    }
    /**
     * Get PnrPaxCredit value
     * @return \StructType\AAPnrPaxCreditType[]|null
     */
    public function getPnrPaxCredit()
    {
        return $this->PnrPaxCredit;
    }
    /**
     * Set PnrPaxCredit value
     * @throws \InvalidArgumentException
     * @param \StructType\AAPnrPaxCreditType[] $pnrPaxCredit
     * @return \StructType\AAPnrPaxCreditsType
     */
    public function setPnrPaxCredit(array $pnrPaxCredit = array())
    {
        foreach ($pnrPaxCredit as $aAPnrPaxCreditsTypePnrPaxCreditItem) {
            // validation for constraint: itemType
            if (!$aAPnrPaxCreditsTypePnrPaxCreditItem instanceof \StructType\AAPnrPaxCreditType) {
                throw new \InvalidArgumentException(sprintf('The PnrPaxCredit property can only contain items of \StructType\AAPnrPaxCreditType, "%s" given', is_object($aAPnrPaxCreditsTypePnrPaxCreditItem) ? get_class($aAPnrPaxCreditsTypePnrPaxCreditItem) : gettype($aAPnrPaxCreditsTypePnrPaxCreditItem)), __LINE__);
            }
        }
        $this->PnrPaxCredit = $pnrPaxCredit;
        return $this;
    }
    /**
     * Add item to PnrPaxCredit value
     * @throws \InvalidArgumentException
     * @param \StructType\AAPnrPaxCreditType $item
     * @return \StructType\AAPnrPaxCreditsType
     */
    public function addToPnrPaxCredit(\StructType\AAPnrPaxCreditType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AAPnrPaxCreditType) {
            throw new \InvalidArgumentException(sprintf('The PnrPaxCredit property can only contain items of \StructType\AAPnrPaxCreditType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PnrPaxCredit[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AAPnrPaxCreditsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
