<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AAPropertiesType StructType
 * Meta informations extracted from the WSDL
 * - documentation: A collection of string properties
 * @subpackage Structs
 */
class AAPropertiesType extends AbstractStructBase
{
    /**
     * The Property
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\AAPropertyType[]
     */
    public $Property;
    /**
     * Constructor method for AAPropertiesType
     * @uses AAPropertiesType::setProperty()
     * @param \StructType\AAPropertyType[] $property
     */
    public function __construct(array $property = array())
    {
        $this
            ->setProperty($property);
    }
    /**
     * Get Property value
     * @return \StructType\AAPropertyType[]|null
     */
    public function getProperty()
    {
        return $this->Property;
    }
    /**
     * Set Property value
     * @throws \InvalidArgumentException
     * @param \StructType\AAPropertyType[] $property
     * @return \StructType\AAPropertiesType
     */
    public function setProperty(array $property = array())
    {
        foreach ($property as $aAPropertiesTypePropertyItem) {
            // validation for constraint: itemType
            if (!$aAPropertiesTypePropertyItem instanceof \StructType\AAPropertyType) {
                throw new \InvalidArgumentException(sprintf('The Property property can only contain items of \StructType\AAPropertyType, "%s" given', is_object($aAPropertiesTypePropertyItem) ? get_class($aAPropertiesTypePropertyItem) : gettype($aAPropertiesTypePropertyItem)), __LINE__);
            }
        }
        $this->Property = $property;
        return $this;
    }
    /**
     * Add item to Property value
     * @throws \InvalidArgumentException
     * @param \StructType\AAPropertyType $item
     * @return \StructType\AAPropertiesType
     */
    public function addToProperty(\StructType\AAPropertyType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AAPropertyType) {
            throw new \InvalidArgumentException(sprintf('The Property property can only contain items of \StructType\AAPropertyType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Property[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AAPropertiesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
