<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AAReconRptCriteriaType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Criteria for extracting transactions for daily reconciliation
 * @subpackage Structs
 */
class AAReconRptCriteriaType extends AbstractStructBase
{
    /**
     * The startTimestamp
     * @var string
     */
    public $startTimestamp;
    /**
     * The endTimestamp
     * @var string
     */
    public $endTimestamp;
    /**
     * Constructor method for AAReconRptCriteriaType
     * @uses AAReconRptCriteriaType::setStartTimestamp()
     * @uses AAReconRptCriteriaType::setEndTimestamp()
     * @param string $startTimestamp
     * @param string $endTimestamp
     */
    public function __construct($startTimestamp = null, $endTimestamp = null)
    {
        $this
            ->setStartTimestamp($startTimestamp)
            ->setEndTimestamp($endTimestamp);
    }
    /**
     * Get startTimestamp value
     * @return string|null
     */
    public function getStartTimestamp()
    {
        return $this->startTimestamp;
    }
    /**
     * Set startTimestamp value
     * @param string $startTimestamp
     * @return \StructType\AAReconRptCriteriaType
     */
    public function setStartTimestamp($startTimestamp = null)
    {
        // validation for constraint: string
        if (!is_null($startTimestamp) && !is_string($startTimestamp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($startTimestamp)), __LINE__);
        }
        $this->startTimestamp = $startTimestamp;
        return $this;
    }
    /**
     * Get endTimestamp value
     * @return string|null
     */
    public function getEndTimestamp()
    {
        return $this->endTimestamp;
    }
    /**
     * Set endTimestamp value
     * @param string $endTimestamp
     * @return \StructType\AAReconRptCriteriaType
     */
    public function setEndTimestamp($endTimestamp = null)
    {
        // validation for constraint: string
        if (!is_null($endTimestamp) && !is_string($endTimestamp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($endTimestamp)), __LINE__);
        }
        $this->endTimestamp = $endTimestamp;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AAReconRptCriteriaType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
