<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AAStatusErrorsAndWarnings StructType
 * @subpackage Structs
 */
class AAStatusErrorsAndWarnings extends AbstractStructBase
{
    /**
     * The success
     * Meta informations extracted from the WSDL
     * - use: required
     * @var bool
     */
    public $success;
    /**
     * The ErrorCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ErrorCode;
    /**
     * The ErrorText
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ErrorText;
    /**
     * The warningMessage
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $warningMessage;
    /**
     * Constructor method for AAStatusErrorsAndWarnings
     * @uses AAStatusErrorsAndWarnings::setSuccess()
     * @uses AAStatusErrorsAndWarnings::setErrorCode()
     * @uses AAStatusErrorsAndWarnings::setErrorText()
     * @uses AAStatusErrorsAndWarnings::setWarningMessage()
     * @param bool $success
     * @param string $errorCode
     * @param string $errorText
     * @param string $warningMessage
     */
    public function __construct($success = null, $errorCode = null, $errorText = null, $warningMessage = null)
    {
        $this
            ->setSuccess($success)
            ->setErrorCode($errorCode)
            ->setErrorText($errorText)
            ->setWarningMessage($warningMessage);
    }
    /**
     * Get success value
     * @return bool
     */
    public function getSuccess()
    {
        return $this->success;
    }
    /**
     * Set success value
     * @param bool $success
     * @return \StructType\AAStatusErrorsAndWarnings
     */
    public function setSuccess($success = null)
    {
        // validation for constraint: boolean
        if (!is_null($success) && !is_bool($success)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($success)), __LINE__);
        }
        $this->success = $success;
        return $this;
    }
    /**
     * Get ErrorCode value
     * @return string|null
     */
    public function getErrorCode()
    {
        return $this->ErrorCode;
    }
    /**
     * Set ErrorCode value
     * @param string $errorCode
     * @return \StructType\AAStatusErrorsAndWarnings
     */
    public function setErrorCode($errorCode = null)
    {
        // validation for constraint: string
        if (!is_null($errorCode) && !is_string($errorCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($errorCode)), __LINE__);
        }
        $this->ErrorCode = $errorCode;
        return $this;
    }
    /**
     * Get ErrorText value
     * @return string|null
     */
    public function getErrorText()
    {
        return $this->ErrorText;
    }
    /**
     * Set ErrorText value
     * @param string $errorText
     * @return \StructType\AAStatusErrorsAndWarnings
     */
    public function setErrorText($errorText = null)
    {
        // validation for constraint: string
        if (!is_null($errorText) && !is_string($errorText)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($errorText)), __LINE__);
        }
        $this->ErrorText = $errorText;
        return $this;
    }
    /**
     * Get warningMessage value
     * @return string|null
     */
    public function getWarningMessage()
    {
        return $this->warningMessage;
    }
    /**
     * Set warningMessage value
     * @param string $warningMessage
     * @return \StructType\AAStatusErrorsAndWarnings
     */
    public function setWarningMessage($warningMessage = null)
    {
        // validation for constraint: string
        if (!is_null($warningMessage) && !is_string($warningMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($warningMessage)), __LINE__);
        }
        $this->warningMessage = $warningMessage;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AAStatusErrorsAndWarnings
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
