<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AATaxesType StructType
 * @subpackage Structs
 */
class AATaxesType extends AbstractStructBase
{
    /**
     * The tax
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\AATaxType[]
     */
    public $tax;
    /**
     * Constructor method for AATaxesType
     * @uses AATaxesType::setTax()
     * @param \StructType\AATaxType[] $tax
     */
    public function __construct(array $tax = array())
    {
        $this
            ->setTax($tax);
    }
    /**
     * Get tax value
     * @return \StructType\AATaxType[]|null
     */
    public function getTax()
    {
        return $this->tax;
    }
    /**
     * Set tax value
     * @throws \InvalidArgumentException
     * @param \StructType\AATaxType[] $tax
     * @return \StructType\AATaxesType
     */
    public function setTax(array $tax = array())
    {
        foreach ($tax as $aATaxesTypeTaxItem) {
            // validation for constraint: itemType
            if (!$aATaxesTypeTaxItem instanceof \StructType\AATaxType) {
                throw new \InvalidArgumentException(sprintf('The tax property can only contain items of \StructType\AATaxType, "%s" given', is_object($aATaxesTypeTaxItem) ? get_class($aATaxesTypeTaxItem) : gettype($aATaxesTypeTaxItem)), __LINE__);
            }
        }
        $this->tax = $tax;
        return $this;
    }
    /**
     * Add item to tax value
     * @throws \InvalidArgumentException
     * @param \StructType\AATaxType $item
     * @return \StructType\AATaxesType
     */
    public function addToTax(\StructType\AATaxType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AATaxType) {
            throw new \InvalidArgumentException(sprintf('The tax property can only contain items of \StructType\AATaxType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->tax[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AATaxesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
