<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AATravelersAccSummaryType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Traveler(PAX) wise Account Summary
 * @subpackage Structs
 */
class AATravelersAccSummaryType extends AbstractStructBase
{
    /**
     * The TravelerAccSummary
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\AATravelerAccSummaryType[]
     */
    public $TravelerAccSummary;
    /**
     * Constructor method for AATravelersAccSummaryType
     * @uses AATravelersAccSummaryType::setTravelerAccSummary()
     * @param \StructType\AATravelerAccSummaryType[] $travelerAccSummary
     */
    public function __construct(array $travelerAccSummary = array())
    {
        $this
            ->setTravelerAccSummary($travelerAccSummary);
    }
    /**
     * Get TravelerAccSummary value
     * @return \StructType\AATravelerAccSummaryType[]|null
     */
    public function getTravelerAccSummary()
    {
        return $this->TravelerAccSummary;
    }
    /**
     * Set TravelerAccSummary value
     * @throws \InvalidArgumentException
     * @param \StructType\AATravelerAccSummaryType[] $travelerAccSummary
     * @return \StructType\AATravelersAccSummaryType
     */
    public function setTravelerAccSummary(array $travelerAccSummary = array())
    {
        foreach ($travelerAccSummary as $aATravelersAccSummaryTypeTravelerAccSummaryItem) {
            // validation for constraint: itemType
            if (!$aATravelersAccSummaryTypeTravelerAccSummaryItem instanceof \StructType\AATravelerAccSummaryType) {
                throw new \InvalidArgumentException(sprintf('The TravelerAccSummary property can only contain items of \StructType\AATravelerAccSummaryType, "%s" given', is_object($aATravelersAccSummaryTypeTravelerAccSummaryItem) ? get_class($aATravelersAccSummaryTypeTravelerAccSummaryItem) : gettype($aATravelersAccSummaryTypeTravelerAccSummaryItem)), __LINE__);
            }
        }
        $this->TravelerAccSummary = $travelerAccSummary;
        return $this;
    }
    /**
     * Add item to TravelerAccSummary value
     * @throws \InvalidArgumentException
     * @param \StructType\AATravelerAccSummaryType $item
     * @return \StructType\AATravelersAccSummaryType
     */
    public function addToTravelerAccSummary(\StructType\AATravelerAccSummaryType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AATravelerAccSummaryType) {
            throw new \InvalidArgumentException(sprintf('The TravelerAccSummary property can only contain items of \StructType\AATravelerAccSummaryType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TravelerAccSummary[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AATravelersAccSummaryType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
