<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AATravelersCnxModAddResBalancesType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Travelers wise balances for reservation modification with respect to the overall reservation (total charges before modification, total charges after modification, total payment, total balance to pay)
 * @subpackage Structs
 */
class AATravelersCnxModAddResBalancesType extends AbstractStructBase
{
    /**
     * The TravelerCnxModAddResBalances
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\AATravelerCnxModAddResBalancesType[]
     */
    public $TravelerCnxModAddResBalances;
    /**
     * Constructor method for AATravelersCnxModAddResBalancesType
     * @uses AATravelersCnxModAddResBalancesType::setTravelerCnxModAddResBalances()
     * @param \StructType\AATravelerCnxModAddResBalancesType[] $travelerCnxModAddResBalances
     */
    public function __construct(array $travelerCnxModAddResBalances = array())
    {
        $this
            ->setTravelerCnxModAddResBalances($travelerCnxModAddResBalances);
    }
    /**
     * Get TravelerCnxModAddResBalances value
     * @return \StructType\AATravelerCnxModAddResBalancesType[]|null
     */
    public function getTravelerCnxModAddResBalances()
    {
        return $this->TravelerCnxModAddResBalances;
    }
    /**
     * Set TravelerCnxModAddResBalances value
     * @throws \InvalidArgumentException
     * @param \StructType\AATravelerCnxModAddResBalancesType[] $travelerCnxModAddResBalances
     * @return \StructType\AATravelersCnxModAddResBalancesType
     */
    public function setTravelerCnxModAddResBalances(array $travelerCnxModAddResBalances = array())
    {
        foreach ($travelerCnxModAddResBalances as $aATravelersCnxModAddResBalancesTypeTravelerCnxModAddResBalancesItem) {
            // validation for constraint: itemType
            if (!$aATravelersCnxModAddResBalancesTypeTravelerCnxModAddResBalancesItem instanceof \StructType\AATravelerCnxModAddResBalancesType) {
                throw new \InvalidArgumentException(sprintf('The TravelerCnxModAddResBalances property can only contain items of \StructType\AATravelerCnxModAddResBalancesType, "%s" given', is_object($aATravelersCnxModAddResBalancesTypeTravelerCnxModAddResBalancesItem) ? get_class($aATravelersCnxModAddResBalancesTypeTravelerCnxModAddResBalancesItem) : gettype($aATravelersCnxModAddResBalancesTypeTravelerCnxModAddResBalancesItem)), __LINE__);
            }
        }
        $this->TravelerCnxModAddResBalances = $travelerCnxModAddResBalances;
        return $this;
    }
    /**
     * Add item to TravelerCnxModAddResBalances value
     * @throws \InvalidArgumentException
     * @param \StructType\AATravelerCnxModAddResBalancesType $item
     * @return \StructType\AATravelersCnxModAddResBalancesType
     */
    public function addToTravelerCnxModAddResBalances(\StructType\AATravelerCnxModAddResBalancesType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AATravelerCnxModAddResBalancesType) {
            throw new \InvalidArgumentException(sprintf('The TravelerCnxModAddResBalances property can only contain items of \StructType\AATravelerCnxModAddResBalancesType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TravelerCnxModAddResBalances[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AATravelersCnxModAddResBalancesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
