<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AAUpdateOptimizedInventoryRQ StructType
 * Meta informations extracted from the WSDL
 * - type: ns3:AAUpdateOptimizedInventoryRQ
 * @subpackage Structs
 */
class AAUpdateOptimizedInventoryRQ extends AbstractStructBase
{
    /**
     * The flightNumber
     * @var string
     */
    public $flightNumber;
    /**
     * The segmentCode
     * @var string
     */
    public $segmentCode;
    /**
     * The depatureDate
     * @var string
     */
    public $depatureDate;
    /**
     * The cabinClass
     * @var string
     */
    public $cabinClass;
    /**
     * The messageDate
     * @var string
     */
    public $messageDate;
    /**
     * The inventorySeatMovements
     * @var \StructType\AAInventorySeatMovementsType
     */
    public $inventorySeatMovements;
    /**
     * The UserId
     * @var string
     */
    public $UserId;
    /**
     * The ChannelId
     * @var string
     */
    public $ChannelId;
    /**
     * Constructor method for AAUpdateOptimizedInventoryRQ
     * @uses AAUpdateOptimizedInventoryRQ::setFlightNumber()
     * @uses AAUpdateOptimizedInventoryRQ::setSegmentCode()
     * @uses AAUpdateOptimizedInventoryRQ::setDepatureDate()
     * @uses AAUpdateOptimizedInventoryRQ::setCabinClass()
     * @uses AAUpdateOptimizedInventoryRQ::setMessageDate()
     * @uses AAUpdateOptimizedInventoryRQ::setInventorySeatMovements()
     * @uses AAUpdateOptimizedInventoryRQ::setUserId()
     * @uses AAUpdateOptimizedInventoryRQ::setChannelId()
     * @param string $flightNumber
     * @param string $segmentCode
     * @param string $depatureDate
     * @param string $cabinClass
     * @param string $messageDate
     * @param \StructType\AAInventorySeatMovementsType $inventorySeatMovements
     * @param string $userId
     * @param string $channelId
     */
    public function __construct($flightNumber = null, $segmentCode = null, $depatureDate = null, $cabinClass = null, $messageDate = null, \StructType\AAInventorySeatMovementsType $inventorySeatMovements = null, $userId = null, $channelId = null)
    {
        $this
            ->setFlightNumber($flightNumber)
            ->setSegmentCode($segmentCode)
            ->setDepatureDate($depatureDate)
            ->setCabinClass($cabinClass)
            ->setMessageDate($messageDate)
            ->setInventorySeatMovements($inventorySeatMovements)
            ->setUserId($userId)
            ->setChannelId($channelId);
    }
    /**
     * Get flightNumber value
     * @return string|null
     */
    public function getFlightNumber()
    {
        return $this->flightNumber;
    }
    /**
     * Set flightNumber value
     * @param string $flightNumber
     * @return \StructType\AAUpdateOptimizedInventoryRQ
     */
    public function setFlightNumber($flightNumber = null)
    {
        // validation for constraint: string
        if (!is_null($flightNumber) && !is_string($flightNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($flightNumber)), __LINE__);
        }
        $this->flightNumber = $flightNumber;
        return $this;
    }
    /**
     * Get segmentCode value
     * @return string|null
     */
    public function getSegmentCode()
    {
        return $this->segmentCode;
    }
    /**
     * Set segmentCode value
     * @param string $segmentCode
     * @return \StructType\AAUpdateOptimizedInventoryRQ
     */
    public function setSegmentCode($segmentCode = null)
    {
        // validation for constraint: string
        if (!is_null($segmentCode) && !is_string($segmentCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($segmentCode)), __LINE__);
        }
        $this->segmentCode = $segmentCode;
        return $this;
    }
    /**
     * Get depatureDate value
     * @return string|null
     */
    public function getDepatureDate()
    {
        return $this->depatureDate;
    }
    /**
     * Set depatureDate value
     * @param string $depatureDate
     * @return \StructType\AAUpdateOptimizedInventoryRQ
     */
    public function setDepatureDate($depatureDate = null)
    {
        // validation for constraint: string
        if (!is_null($depatureDate) && !is_string($depatureDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($depatureDate)), __LINE__);
        }
        $this->depatureDate = $depatureDate;
        return $this;
    }
    /**
     * Get cabinClass value
     * @return string|null
     */
    public function getCabinClass()
    {
        return $this->cabinClass;
    }
    /**
     * Set cabinClass value
     * @param string $cabinClass
     * @return \StructType\AAUpdateOptimizedInventoryRQ
     */
    public function setCabinClass($cabinClass = null)
    {
        // validation for constraint: string
        if (!is_null($cabinClass) && !is_string($cabinClass)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cabinClass)), __LINE__);
        }
        $this->cabinClass = $cabinClass;
        return $this;
    }
    /**
     * Get messageDate value
     * @return string|null
     */
    public function getMessageDate()
    {
        return $this->messageDate;
    }
    /**
     * Set messageDate value
     * @param string $messageDate
     * @return \StructType\AAUpdateOptimizedInventoryRQ
     */
    public function setMessageDate($messageDate = null)
    {
        // validation for constraint: string
        if (!is_null($messageDate) && !is_string($messageDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($messageDate)), __LINE__);
        }
        $this->messageDate = $messageDate;
        return $this;
    }
    /**
     * Get inventorySeatMovements value
     * @return \StructType\AAInventorySeatMovementsType|null
     */
    public function getInventorySeatMovements()
    {
        return $this->inventorySeatMovements;
    }
    /**
     * Set inventorySeatMovements value
     * @param \StructType\AAInventorySeatMovementsType $inventorySeatMovements
     * @return \StructType\AAUpdateOptimizedInventoryRQ
     */
    public function setInventorySeatMovements(\StructType\AAInventorySeatMovementsType $inventorySeatMovements = null)
    {
        $this->inventorySeatMovements = $inventorySeatMovements;
        return $this;
    }
    /**
     * Get UserId value
     * @return string|null
     */
    public function getUserId()
    {
        return $this->UserId;
    }
    /**
     * Set UserId value
     * @param string $userId
     * @return \StructType\AAUpdateOptimizedInventoryRQ
     */
    public function setUserId($userId = null)
    {
        // validation for constraint: string
        if (!is_null($userId) && !is_string($userId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($userId)), __LINE__);
        }
        $this->UserId = $userId;
        return $this;
    }
    /**
     * Get ChannelId value
     * @return string|null
     */
    public function getChannelId()
    {
        return $this->ChannelId;
    }
    /**
     * Set ChannelId value
     * @param string $channelId
     * @return \StructType\AAUpdateOptimizedInventoryRQ
     */
    public function setChannelId($channelId = null)
    {
        // validation for constraint: string
        if (!is_null($channelId) && !is_string($channelId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($channelId)), __LINE__);
        }
        $this->ChannelId = $channelId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AAUpdateOptimizedInventoryRQ
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
