<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AAUserNotesType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Free Text Notes
 * @subpackage Structs
 */
class AAUserNotesType extends AbstractStructBase
{
    /**
     * The UserNote
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\AAUserNoteType[]
     */
    public $UserNote;
    /**
     * Constructor method for AAUserNotesType
     * @uses AAUserNotesType::setUserNote()
     * @param \StructType\AAUserNoteType[] $userNote
     */
    public function __construct(array $userNote = array())
    {
        $this
            ->setUserNote($userNote);
    }
    /**
     * Get UserNote value
     * @return \StructType\AAUserNoteType[]|null
     */
    public function getUserNote()
    {
        return $this->UserNote;
    }
    /**
     * Set UserNote value
     * @throws \InvalidArgumentException
     * @param \StructType\AAUserNoteType[] $userNote
     * @return \StructType\AAUserNotesType
     */
    public function setUserNote(array $userNote = array())
    {
        foreach ($userNote as $aAUserNotesTypeUserNoteItem) {
            // validation for constraint: itemType
            if (!$aAUserNotesTypeUserNoteItem instanceof \StructType\AAUserNoteType) {
                throw new \InvalidArgumentException(sprintf('The UserNote property can only contain items of \StructType\AAUserNoteType, "%s" given', is_object($aAUserNotesTypeUserNoteItem) ? get_class($aAUserNotesTypeUserNoteItem) : gettype($aAUserNotesTypeUserNoteItem)), __LINE__);
            }
        }
        $this->UserNote = $userNote;
        return $this;
    }
    /**
     * Add item to UserNote value
     * @throws \InvalidArgumentException
     * @param \StructType\AAUserNoteType $item
     * @return \StructType\AAUserNotesType
     */
    public function addToUserNote(\StructType\AAUserNoteType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AAUserNoteType) {
            throw new \InvalidArgumentException(sprintf('The UserNote property can only contain items of \StructType\AAUserNoteType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->UserNote[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AAUserNotesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
