<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AA_OTA_PFSUpdateRQ StructType
 * Meta informations extracted from the WSDL
 * - type: ns5:AA_OTA_PFSUpdateRQ
 * @subpackage Structs
 */
class AA_OTA_PFSUpdateRQ extends AbstractStructBase
{
    /**
     * The pfsPaxs
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\PFSPax[]
     */
    public $pfsPaxs;
    /**
     * The flight
     * @var \StructType\PFSFlight
     */
    public $flight;
    /**
     * Constructor method for AA_OTA_PFSUpdateRQ
     * @uses AA_OTA_PFSUpdateRQ::setPfsPaxs()
     * @uses AA_OTA_PFSUpdateRQ::setFlight()
     * @param \StructType\PFSPax[] $pfsPaxs
     * @param \StructType\PFSFlight $flight
     */
    public function __construct(array $pfsPaxs = array(), \StructType\PFSFlight $flight = null)
    {
        $this
            ->setPfsPaxs($pfsPaxs)
            ->setFlight($flight);
    }
    /**
     * Get pfsPaxs value
     * @return \StructType\PFSPax[]|null
     */
    public function getPfsPaxs()
    {
        return $this->pfsPaxs;
    }
    /**
     * Set pfsPaxs value
     * @throws \InvalidArgumentException
     * @param \StructType\PFSPax[] $pfsPaxs
     * @return \StructType\AA_OTA_PFSUpdateRQ
     */
    public function setPfsPaxs(array $pfsPaxs = array())
    {
        foreach ($pfsPaxs as $aA_OTA_PFSUpdateRQPfsPaxsItem) {
            // validation for constraint: itemType
            if (!$aA_OTA_PFSUpdateRQPfsPaxsItem instanceof \StructType\PFSPax) {
                throw new \InvalidArgumentException(sprintf('The pfsPaxs property can only contain items of \StructType\PFSPax, "%s" given', is_object($aA_OTA_PFSUpdateRQPfsPaxsItem) ? get_class($aA_OTA_PFSUpdateRQPfsPaxsItem) : gettype($aA_OTA_PFSUpdateRQPfsPaxsItem)), __LINE__);
            }
        }
        $this->pfsPaxs = $pfsPaxs;
        return $this;
    }
    /**
     * Add item to pfsPaxs value
     * @throws \InvalidArgumentException
     * @param \StructType\PFSPax $item
     * @return \StructType\AA_OTA_PFSUpdateRQ
     */
    public function addToPfsPaxs(\StructType\PFSPax $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PFSPax) {
            throw new \InvalidArgumentException(sprintf('The pfsPaxs property can only contain items of \StructType\PFSPax, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->pfsPaxs[] = $item;
        return $this;
    }
    /**
     * Get flight value
     * @return \StructType\PFSFlight|null
     */
    public function getFlight()
    {
        return $this->flight;
    }
    /**
     * Set flight value
     * @param \StructType\PFSFlight $flight
     * @return \StructType\AA_OTA_PFSUpdateRQ
     */
    public function setFlight(\StructType\PFSFlight $flight = null)
    {
        $this->flight = $flight;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AA_OTA_PFSUpdateRQ
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
