<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AllowedFlexiOperations StructType
 * Meta informations extracted from the WSDL
 * - documentation: The breakdown of flexifare
 * @subpackage Structs
 */
class AllowedFlexiOperations extends AbstractStructBase
{
    /**
     * The FlexiOperations
     * Meta informations extracted from the WSDL
     * - documentation: The flexibility operations allowed.
     * - maxOccurs: 10
     * @var mixed[]
     */
    public $FlexiOperations;
    /**
     * Constructor method for AllowedFlexiOperations
     * @uses AllowedFlexiOperations::setFlexiOperations()
     * @param mixed[] $flexiOperations
     */
    public function __construct(array $flexiOperations = array())
    {
        $this
            ->setFlexiOperations($flexiOperations);
    }
    /**
     * Get FlexiOperations value
     * @return mixed[]|null
     */
    public function getFlexiOperations()
    {
        return $this->FlexiOperations;
    }
    /**
     * Set FlexiOperations value
     * @throws \InvalidArgumentException
     * @param mixed[] $flexiOperations
     * @return \StructType\AllowedFlexiOperations
     */
    public function setFlexiOperations(array $flexiOperations = array())
    {
        foreach ($flexiOperations as $allowedFlexiOperationsFlexiOperationsItem) {
            // validation for constraint: itemType
            if (!false) {
                throw new \InvalidArgumentException(sprintf('The FlexiOperations property can only contain items of anyType, "%s" given', is_object($allowedFlexiOperationsFlexiOperationsItem) ? get_class($allowedFlexiOperationsFlexiOperationsItem) : gettype($allowedFlexiOperationsFlexiOperationsItem)), __LINE__);
            }
        }
        $this->FlexiOperations = $flexiOperations;
        return $this;
    }
    /**
     * Add item to FlexiOperations value
     * @throws \InvalidArgumentException
     * @param mixed $item
     * @return \StructType\AllowedFlexiOperations
     */
    public function addToFlexiOperations($item)
    {
        // validation for constraint: itemType
        if (!false) {
            throw new \InvalidArgumentException(sprintf('The FlexiOperations property can only contain items of anyType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->FlexiOperations[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AllowedFlexiOperations
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
