<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AvailableFlexiOperations StructType
 * Meta informations extracted from the WSDL
 * - documentation: The available flexibility operations for this booking flight segment
 * @subpackage Structs
 */
class AvailableFlexiOperations extends AbstractStructBase
{
    /**
     * The FlexiOperations
     * Meta informations extracted from the WSDL
     * - documentation: The flexibility operations allowed.
     * - maxOccurs: 10
     * @var mixed[]
     */
    public $FlexiOperations;
    /**
     * Constructor method for AvailableFlexiOperations
     * @uses AvailableFlexiOperations::setFlexiOperations()
     * @param mixed[] $flexiOperations
     */
    public function __construct(array $flexiOperations = array())
    {
        $this
            ->setFlexiOperations($flexiOperations);
    }
    /**
     * Get FlexiOperations value
     * @return mixed[]|null
     */
    public function getFlexiOperations()
    {
        return $this->FlexiOperations;
    }
    /**
     * Set FlexiOperations value
     * @throws \InvalidArgumentException
     * @param mixed[] $flexiOperations
     * @return \StructType\AvailableFlexiOperations
     */
    public function setFlexiOperations(array $flexiOperations = array())
    {
        foreach ($flexiOperations as $availableFlexiOperationsFlexiOperationsItem) {
            // validation for constraint: itemType
            if (!false) {
                throw new \InvalidArgumentException(sprintf('The FlexiOperations property can only contain items of anyType, "%s" given', is_object($availableFlexiOperationsFlexiOperationsItem) ? get_class($availableFlexiOperationsFlexiOperationsItem) : gettype($availableFlexiOperationsFlexiOperationsItem)), __LINE__);
            }
        }
        $this->FlexiOperations = $flexiOperations;
        return $this;
    }
    /**
     * Add item to FlexiOperations value
     * @throws \InvalidArgumentException
     * @param mixed $item
     * @return \StructType\AvailableFlexiOperations
     */
    public function addToFlexiOperations($item)
    {
        // validation for constraint: itemType
        if (!false) {
            throw new \InvalidArgumentException(sprintf('The FlexiOperations property can only contain items of anyType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->FlexiOperations[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AvailableFlexiOperations
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
