<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Baggage StructType
 * @subpackage Structs
 */
class Baggage extends AbstractStructBase
{
    /**
     * The baggageCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $baggageCode;
    /**
     * The baggageDescription
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $baggageDescription;
    /**
     * The baggageCharge
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var float
     */
    public $baggageCharge;
    /**
     * The currencyCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var mixed
     */
    public $currencyCode;
    /**
     * Constructor method for Baggage
     * @uses Baggage::setBaggageCode()
     * @uses Baggage::setBaggageDescription()
     * @uses Baggage::setBaggageCharge()
     * @uses Baggage::setCurrencyCode()
     * @param string $baggageCode
     * @param string $baggageDescription
     * @param float $baggageCharge
     * @param mixed $currencyCode
     */
    public function __construct($baggageCode = null, $baggageDescription = null, $baggageCharge = null, $currencyCode = null)
    {
        $this
            ->setBaggageCode($baggageCode)
            ->setBaggageDescription($baggageDescription)
            ->setBaggageCharge($baggageCharge)
            ->setCurrencyCode($currencyCode);
    }
    /**
     * Get baggageCode value
     * @return string
     */
    public function getBaggageCode()
    {
        return $this->baggageCode;
    }
    /**
     * Set baggageCode value
     * @param string $baggageCode
     * @return \StructType\Baggage
     */
    public function setBaggageCode($baggageCode = null)
    {
        // validation for constraint: string
        if (!is_null($baggageCode) && !is_string($baggageCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($baggageCode)), __LINE__);
        }
        $this->baggageCode = $baggageCode;
        return $this;
    }
    /**
     * Get baggageDescription value
     * @return string
     */
    public function getBaggageDescription()
    {
        return $this->baggageDescription;
    }
    /**
     * Set baggageDescription value
     * @param string $baggageDescription
     * @return \StructType\Baggage
     */
    public function setBaggageDescription($baggageDescription = null)
    {
        // validation for constraint: string
        if (!is_null($baggageDescription) && !is_string($baggageDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($baggageDescription)), __LINE__);
        }
        $this->baggageDescription = $baggageDescription;
        return $this;
    }
    /**
     * Get baggageCharge value
     * @return float
     */
    public function getBaggageCharge()
    {
        return $this->baggageCharge;
    }
    /**
     * Set baggageCharge value
     * @param float $baggageCharge
     * @return \StructType\Baggage
     */
    public function setBaggageCharge($baggageCharge = null)
    {
        $this->baggageCharge = $baggageCharge;
        return $this;
    }
    /**
     * Get currencyCode value
     * @return mixed
     */
    public function getCurrencyCode()
    {
        return $this->currencyCode;
    }
    /**
     * Set currencyCode value
     * @param mixed $currencyCode
     * @return \StructType\Baggage
     */
    public function setCurrencyCode($currencyCode = null)
    {
        $this->currencyCode = $currencyCode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Baggage
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
