<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BaggageDetailsRequests StructType
 * Meta informations extracted from the WSDL
 * - documentation: The baggage details request element containing the details of the request.
 * @subpackage Structs
 */
class BaggageDetailsRequests extends AbstractStructBase
{
    /**
     * The BaggageDetailsRequest
     * Meta informations extracted from the WSDL
     * - maxOccurs: 99
     * - minOccurs: 0
     * @var \StructType\BaggageDetailsRequest[]
     */
    public $BaggageDetailsRequest;
    /**
     * Constructor method for BaggageDetailsRequests
     * @uses BaggageDetailsRequests::setBaggageDetailsRequest()
     * @param \StructType\BaggageDetailsRequest[] $baggageDetailsRequest
     */
    public function __construct(array $baggageDetailsRequest = array())
    {
        $this
            ->setBaggageDetailsRequest($baggageDetailsRequest);
    }
    /**
     * Get BaggageDetailsRequest value
     * @return \StructType\BaggageDetailsRequest[]|null
     */
    public function getBaggageDetailsRequest()
    {
        return $this->BaggageDetailsRequest;
    }
    /**
     * Set BaggageDetailsRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\BaggageDetailsRequest[] $baggageDetailsRequest
     * @return \StructType\BaggageDetailsRequests
     */
    public function setBaggageDetailsRequest(array $baggageDetailsRequest = array())
    {
        foreach ($baggageDetailsRequest as $baggageDetailsRequestsBaggageDetailsRequestItem) {
            // validation for constraint: itemType
            if (!$baggageDetailsRequestsBaggageDetailsRequestItem instanceof \StructType\BaggageDetailsRequest) {
                throw new \InvalidArgumentException(sprintf('The BaggageDetailsRequest property can only contain items of \StructType\BaggageDetailsRequest, "%s" given', is_object($baggageDetailsRequestsBaggageDetailsRequestItem) ? get_class($baggageDetailsRequestsBaggageDetailsRequestItem) : gettype($baggageDetailsRequestsBaggageDetailsRequestItem)), __LINE__);
            }
        }
        $this->BaggageDetailsRequest = $baggageDetailsRequest;
        return $this;
    }
    /**
     * Add item to BaggageDetailsRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\BaggageDetailsRequest $item
     * @return \StructType\BaggageDetailsRequests
     */
    public function addToBaggageDetailsRequest(\StructType\BaggageDetailsRequest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BaggageDetailsRequest) {
            throw new \InvalidArgumentException(sprintf('The BaggageDetailsRequest property can only contain items of \StructType\BaggageDetailsRequest, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->BaggageDetailsRequest[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BaggageDetailsRequests
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
