<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BaggageRequests StructType
 * Meta informations extracted from the WSDL
 * - documentation: A collection of Meal Request
 * @subpackage Structs
 */
class BaggageRequests extends AbstractStructBase
{
    /**
     * The BaggageRequest
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\BaggageRequest[]
     */
    public $BaggageRequest;
    /**
     * Constructor method for BaggageRequests
     * @uses BaggageRequests::setBaggageRequest()
     * @param \StructType\BaggageRequest[] $baggageRequest
     */
    public function __construct(array $baggageRequest = array())
    {
        $this
            ->setBaggageRequest($baggageRequest);
    }
    /**
     * Get BaggageRequest value
     * @return \StructType\BaggageRequest[]|null
     */
    public function getBaggageRequest()
    {
        return $this->BaggageRequest;
    }
    /**
     * Set BaggageRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\BaggageRequest[] $baggageRequest
     * @return \StructType\BaggageRequests
     */
    public function setBaggageRequest(array $baggageRequest = array())
    {
        foreach ($baggageRequest as $baggageRequestsBaggageRequestItem) {
            // validation for constraint: itemType
            if (!$baggageRequestsBaggageRequestItem instanceof \StructType\BaggageRequest) {
                throw new \InvalidArgumentException(sprintf('The BaggageRequest property can only contain items of \StructType\BaggageRequest, "%s" given', is_object($baggageRequestsBaggageRequestItem) ? get_class($baggageRequestsBaggageRequestItem) : gettype($baggageRequestsBaggageRequestItem)), __LINE__);
            }
        }
        $this->BaggageRequest = $baggageRequest;
        return $this;
    }
    /**
     * Add item to BaggageRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\BaggageRequest $item
     * @return \StructType\BaggageRequests
     */
    public function addToBaggageRequest(\StructType\BaggageRequest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BaggageRequest) {
            throw new \InvalidArgumentException(sprintf('The BaggageRequest property can only contain items of \StructType\BaggageRequest, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->BaggageRequest[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BaggageRequests
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
