<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BundledServiceSelectionOptions StructType
 * Meta informations extracted from the WSDL
 * - documentation: Bundled Services selection options.
 * @subpackage Structs
 */
class BundledServiceSelectionOptions extends AbstractStructBase
{
    /**
     * The OutBoundBunldedServiceId
     * Meta informations extracted from the WSDL
     * - documentation: Bundled service ID from available bundled services
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $OutBoundBunldedServiceId;
    /**
     * The InBoundBunldedServiceId
     * Meta informations extracted from the WSDL
     * - documentation: Bundled service ID from available bundled services
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $InBoundBunldedServiceId;
    /**
     * Constructor method for BundledServiceSelectionOptions
     * @uses BundledServiceSelectionOptions::setOutBoundBunldedServiceId()
     * @uses BundledServiceSelectionOptions::setInBoundBunldedServiceId()
     * @param int $outBoundBunldedServiceId
     * @param int $inBoundBunldedServiceId
     */
    public function __construct($outBoundBunldedServiceId = null, $inBoundBunldedServiceId = null)
    {
        $this
            ->setOutBoundBunldedServiceId($outBoundBunldedServiceId)
            ->setInBoundBunldedServiceId($inBoundBunldedServiceId);
    }
    /**
     * Get OutBoundBunldedServiceId value
     * @return int|null
     */
    public function getOutBoundBunldedServiceId()
    {
        return $this->OutBoundBunldedServiceId;
    }
    /**
     * Set OutBoundBunldedServiceId value
     * @param int $outBoundBunldedServiceId
     * @return \StructType\BundledServiceSelectionOptions
     */
    public function setOutBoundBunldedServiceId($outBoundBunldedServiceId = null)
    {
        // validation for constraint: int
        if (!is_null($outBoundBunldedServiceId) && !is_numeric($outBoundBunldedServiceId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($outBoundBunldedServiceId)), __LINE__);
        }
        $this->OutBoundBunldedServiceId = $outBoundBunldedServiceId;
        return $this;
    }
    /**
     * Get InBoundBunldedServiceId value
     * @return int|null
     */
    public function getInBoundBunldedServiceId()
    {
        return $this->InBoundBunldedServiceId;
    }
    /**
     * Set InBoundBunldedServiceId value
     * @param int $inBoundBunldedServiceId
     * @return \StructType\BundledServiceSelectionOptions
     */
    public function setInBoundBunldedServiceId($inBoundBunldedServiceId = null)
    {
        // validation for constraint: int
        if (!is_null($inBoundBunldedServiceId) && !is_numeric($inBoundBunldedServiceId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($inBoundBunldedServiceId)), __LINE__);
        }
        $this->InBoundBunldedServiceId = $inBoundBunldedServiceId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BundledServiceSelectionOptions
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
