<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ETicketInfo StructType
 * Meta informations extracted from the WSDL
 * - documentation: ETicket Information
 * @subpackage Structs
 */
class ETicketInfo extends AbstractStructBase
{
    /**
     * The ETicketInfomation
     * Meta informations extracted from the WSDL
     * - documentation: Reference to the flight segments for this traveler
     * - maxOccurs: 99
     * @var mixed[]
     */
    public $ETicketInfomation;
    /**
     * Constructor method for ETicketInfo
     * @uses ETicketInfo::setETicketInfomation()
     * @param mixed[] $eTicketInfomation
     */
    public function __construct(array $eTicketInfomation = array())
    {
        $this
            ->setETicketInfomation($eTicketInfomation);
    }
    /**
     * Get ETicketInfomation value
     * @return mixed[]|null
     */
    public function getETicketInfomation()
    {
        return $this->ETicketInfomation;
    }
    /**
     * Set ETicketInfomation value
     * @throws \InvalidArgumentException
     * @param mixed[] $eTicketInfomation
     * @return \StructType\ETicketInfo
     */
    public function setETicketInfomation(array $eTicketInfomation = array())
    {
        foreach ($eTicketInfomation as $eTicketInfoETicketInfomationItem) {
            // validation for constraint: itemType
            if (!false) {
                throw new \InvalidArgumentException(sprintf('The ETicketInfomation property can only contain items of anyType, "%s" given', is_object($eTicketInfoETicketInfomationItem) ? get_class($eTicketInfoETicketInfomationItem) : gettype($eTicketInfoETicketInfomationItem)), __LINE__);
            }
        }
        $this->ETicketInfomation = $eTicketInfomation;
        return $this;
    }
    /**
     * Add item to ETicketInfomation value
     * @throws \InvalidArgumentException
     * @param mixed $item
     * @return \StructType\ETicketInfo
     */
    public function addToETicketInfomation($item)
    {
        // validation for constraint: itemType
        if (!false) {
            throw new \InvalidArgumentException(sprintf('The ETicketInfomation property can only contain items of anyType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ETicketInfomation[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ETicketInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
