<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FlightSegmentInfo StructType
 * Meta informations extracted from the WSDL
 * - documentation: The flight segment for which the seat map is sent. | The flight segment for which the meal details are sent. | The flight segment for which the ssr details are sent. | The flight segment for which the baggage details are sent.
 * @subpackage Structs
 */
class FlightSegmentInfo extends FlightSegmentType
{
    /**
     * The Warnings
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\WarningsType
     */
    public $Warnings;
    /**
     * Constructor method for FlightSegmentInfo
     * @uses FlightSegmentInfo::setWarnings()
     * @param \StructType\WarningsType $warnings
     */
    public function __construct(\StructType\WarningsType $warnings = null)
    {
        $this
            ->setWarnings($warnings);
    }
    /**
     * Get Warnings value
     * @return \StructType\WarningsType|null
     */
    public function getWarnings()
    {
        return $this->Warnings;
    }
    /**
     * Set Warnings value
     * @param \StructType\WarningsType $warnings
     * @return \StructType\FlightSegmentInfo
     */
    public function setWarnings(\StructType\WarningsType $warnings = null)
    {
        $this->Warnings = $warnings;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\FlightSegmentInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
