<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InsCoverageType StructType
 * @subpackage Structs
 */
class InsCoverageType extends AbstractStructBase
{
    /**
     * The CoveredTravelers
     * @var \StructType\CoveredTravelers
     */
    public $CoveredTravelers;
    /**
     * The InsCoverageDetail
     * Meta informations extracted from the WSDL
     * - documentation: Provides vendor with information about the traveler(s)' requirements for insurance coverage.
     * @var mixed
     */
    public $InsCoverageDetail;
    /**
     * Constructor method for InsCoverageType
     * @uses InsCoverageType::setCoveredTravelers()
     * @uses InsCoverageType::setInsCoverageDetail()
     * @param \StructType\CoveredTravelers $coveredTravelers
     * @param mixed $insCoverageDetail
     */
    public function __construct(\StructType\CoveredTravelers $coveredTravelers = null, $insCoverageDetail = null)
    {
        $this
            ->setCoveredTravelers($coveredTravelers)
            ->setInsCoverageDetail($insCoverageDetail);
    }
    /**
     * Get CoveredTravelers value
     * @return \StructType\CoveredTravelers|null
     */
    public function getCoveredTravelers()
    {
        return $this->CoveredTravelers;
    }
    /**
     * Set CoveredTravelers value
     * @param \StructType\CoveredTravelers $coveredTravelers
     * @return \StructType\InsCoverageType
     */
    public function setCoveredTravelers(\StructType\CoveredTravelers $coveredTravelers = null)
    {
        $this->CoveredTravelers = $coveredTravelers;
        return $this;
    }
    /**
     * Get InsCoverageDetail value
     * @return mixed|null
     */
    public function getInsCoverageDetail()
    {
        return $this->InsCoverageDetail;
    }
    /**
     * Set InsCoverageDetail value
     * @param mixed $insCoverageDetail
     * @return \StructType\InsCoverageType
     */
    public function setInsCoverageDetail($insCoverageDetail = null)
    {
        $this->InsCoverageDetail = $insCoverageDetail;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\InsCoverageType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
