<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MealDetailsRequests StructType
 * Meta informations extracted from the WSDL
 * - documentation: The meal details request element containing the details of the request.
 * @subpackage Structs
 */
class MealDetailsRequests extends AbstractStructBase
{
    /**
     * The MealDetailsRequest
     * Meta informations extracted from the WSDL
     * - maxOccurs: 99
     * - minOccurs: 0
     * @var \StructType\MealDetailsRequest[]
     */
    public $MealDetailsRequest;
    /**
     * Constructor method for MealDetailsRequests
     * @uses MealDetailsRequests::setMealDetailsRequest()
     * @param \StructType\MealDetailsRequest[] $mealDetailsRequest
     */
    public function __construct(array $mealDetailsRequest = array())
    {
        $this
            ->setMealDetailsRequest($mealDetailsRequest);
    }
    /**
     * Get MealDetailsRequest value
     * @return \StructType\MealDetailsRequest[]|null
     */
    public function getMealDetailsRequest()
    {
        return $this->MealDetailsRequest;
    }
    /**
     * Set MealDetailsRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\MealDetailsRequest[] $mealDetailsRequest
     * @return \StructType\MealDetailsRequests
     */
    public function setMealDetailsRequest(array $mealDetailsRequest = array())
    {
        foreach ($mealDetailsRequest as $mealDetailsRequestsMealDetailsRequestItem) {
            // validation for constraint: itemType
            if (!$mealDetailsRequestsMealDetailsRequestItem instanceof \StructType\MealDetailsRequest) {
                throw new \InvalidArgumentException(sprintf('The MealDetailsRequest property can only contain items of \StructType\MealDetailsRequest, "%s" given', is_object($mealDetailsRequestsMealDetailsRequestItem) ? get_class($mealDetailsRequestsMealDetailsRequestItem) : gettype($mealDetailsRequestsMealDetailsRequestItem)), __LINE__);
            }
        }
        $this->MealDetailsRequest = $mealDetailsRequest;
        return $this;
    }
    /**
     * Add item to MealDetailsRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\MealDetailsRequest $item
     * @return \StructType\MealDetailsRequests
     */
    public function addToMealDetailsRequest(\StructType\MealDetailsRequest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MealDetailsRequest) {
            throw new \InvalidArgumentException(sprintf('The MealDetailsRequest property can only contain items of \StructType\MealDetailsRequest, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->MealDetailsRequest[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\MealDetailsRequests
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
