<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PFSPax StructType
 * @subpackage Structs
 */
class PFSPax extends AbstractStructBase
{
    /**
     * The arrivalAirport
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $arrivalAirport;
    /**
     * The cabinClassCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $cabinClassCode;
    /**
     * The entryStatus
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var mixed
     */
    public $entryStatus;
    /**
     * The firstName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $firstName;
    /**
     * The isParent
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $isParent;
    /**
     * The lastname
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $lastname;
    /**
     * The paxType
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $paxType;
    /**
     * The pnr
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $pnr;
    /**
     * The title
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $title;
    /**
     * The eTicketNo
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $eTicketNo;
    /**
     * The infant
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var mixed
     */
    public $infant;
    /**
     * Constructor method for PFSPax
     * @uses PFSPax::setArrivalAirport()
     * @uses PFSPax::setCabinClassCode()
     * @uses PFSPax::setEntryStatus()
     * @uses PFSPax::setFirstName()
     * @uses PFSPax::setIsParent()
     * @uses PFSPax::setLastname()
     * @uses PFSPax::setPaxType()
     * @uses PFSPax::setPnr()
     * @uses PFSPax::setTitle()
     * @uses PFSPax::setETicketNo()
     * @uses PFSPax::setInfant()
     * @param string $arrivalAirport
     * @param string $cabinClassCode
     * @param mixed $entryStatus
     * @param string $firstName
     * @param string $isParent
     * @param string $lastname
     * @param string $paxType
     * @param string $pnr
     * @param string $title
     * @param string $eTicketNo
     * @param mixed $infant
     */
    public function __construct($arrivalAirport = null, $cabinClassCode = null, $entryStatus = null, $firstName = null, $isParent = null, $lastname = null, $paxType = null, $pnr = null, $title = null, $eTicketNo = null, $infant = null)
    {
        $this
            ->setArrivalAirport($arrivalAirport)
            ->setCabinClassCode($cabinClassCode)
            ->setEntryStatus($entryStatus)
            ->setFirstName($firstName)
            ->setIsParent($isParent)
            ->setLastname($lastname)
            ->setPaxType($paxType)
            ->setPnr($pnr)
            ->setTitle($title)
            ->setETicketNo($eTicketNo)
            ->setInfant($infant);
    }
    /**
     * Get arrivalAirport value
     * @return string|null
     */
    public function getArrivalAirport()
    {
        return $this->arrivalAirport;
    }
    /**
     * Set arrivalAirport value
     * @param string $arrivalAirport
     * @return \StructType\PFSPax
     */
    public function setArrivalAirport($arrivalAirport = null)
    {
        // validation for constraint: string
        if (!is_null($arrivalAirport) && !is_string($arrivalAirport)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($arrivalAirport)), __LINE__);
        }
        $this->arrivalAirport = $arrivalAirport;
        return $this;
    }
    /**
     * Get cabinClassCode value
     * @return string|null
     */
    public function getCabinClassCode()
    {
        return $this->cabinClassCode;
    }
    /**
     * Set cabinClassCode value
     * @param string $cabinClassCode
     * @return \StructType\PFSPax
     */
    public function setCabinClassCode($cabinClassCode = null)
    {
        // validation for constraint: string
        if (!is_null($cabinClassCode) && !is_string($cabinClassCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cabinClassCode)), __LINE__);
        }
        $this->cabinClassCode = $cabinClassCode;
        return $this;
    }
    /**
     * Get entryStatus value
     * @return mixed|null
     */
    public function getEntryStatus()
    {
        return $this->entryStatus;
    }
    /**
     * Set entryStatus value
     * @param mixed $entryStatus
     * @return \StructType\PFSPax
     */
    public function setEntryStatus($entryStatus = null)
    {
        $this->entryStatus = $entryStatus;
        return $this;
    }
    /**
     * Get firstName value
     * @return string|null
     */
    public function getFirstName()
    {
        return $this->firstName;
    }
    /**
     * Set firstName value
     * @param string $firstName
     * @return \StructType\PFSPax
     */
    public function setFirstName($firstName = null)
    {
        // validation for constraint: string
        if (!is_null($firstName) && !is_string($firstName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($firstName)), __LINE__);
        }
        $this->firstName = $firstName;
        return $this;
    }
    /**
     * Get isParent value
     * @return string|null
     */
    public function getIsParent()
    {
        return $this->isParent;
    }
    /**
     * Set isParent value
     * @param string $isParent
     * @return \StructType\PFSPax
     */
    public function setIsParent($isParent = null)
    {
        // validation for constraint: string
        if (!is_null($isParent) && !is_string($isParent)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($isParent)), __LINE__);
        }
        $this->isParent = $isParent;
        return $this;
    }
    /**
     * Get lastname value
     * @return string|null
     */
    public function getLastname()
    {
        return $this->lastname;
    }
    /**
     * Set lastname value
     * @param string $lastname
     * @return \StructType\PFSPax
     */
    public function setLastname($lastname = null)
    {
        // validation for constraint: string
        if (!is_null($lastname) && !is_string($lastname)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lastname)), __LINE__);
        }
        $this->lastname = $lastname;
        return $this;
    }
    /**
     * Get paxType value
     * @return string|null
     */
    public function getPaxType()
    {
        return $this->paxType;
    }
    /**
     * Set paxType value
     * @param string $paxType
     * @return \StructType\PFSPax
     */
    public function setPaxType($paxType = null)
    {
        // validation for constraint: string
        if (!is_null($paxType) && !is_string($paxType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($paxType)), __LINE__);
        }
        $this->paxType = $paxType;
        return $this;
    }
    /**
     * Get pnr value
     * @return string|null
     */
    public function getPnr()
    {
        return $this->pnr;
    }
    /**
     * Set pnr value
     * @param string $pnr
     * @return \StructType\PFSPax
     */
    public function setPnr($pnr = null)
    {
        // validation for constraint: string
        if (!is_null($pnr) && !is_string($pnr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($pnr)), __LINE__);
        }
        $this->pnr = $pnr;
        return $this;
    }
    /**
     * Get title value
     * @return string|null
     */
    public function getTitle()
    {
        return $this->title;
    }
    /**
     * Set title value
     * @param string $title
     * @return \StructType\PFSPax
     */
    public function setTitle($title = null)
    {
        // validation for constraint: string
        if (!is_null($title) && !is_string($title)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($title)), __LINE__);
        }
        $this->title = $title;
        return $this;
    }
    /**
     * Get eTicketNo value
     * @return string|null
     */
    public function getETicketNo()
    {
        return $this->eTicketNo;
    }
    /**
     * Set eTicketNo value
     * @param string $eTicketNo
     * @return \StructType\PFSPax
     */
    public function setETicketNo($eTicketNo = null)
    {
        // validation for constraint: string
        if (!is_null($eTicketNo) && !is_string($eTicketNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($eTicketNo)), __LINE__);
        }
        $this->eTicketNo = $eTicketNo;
        return $this;
    }
    /**
     * Get infant value
     * @return mixed|null
     */
    public function getInfant()
    {
        return $this->infant;
    }
    /**
     * Set infant value
     * @param mixed $infant
     * @return \StructType\PFSPax
     */
    public function setInfant($infant = null)
    {
        $this->infant = $infant;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PFSPax
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
