<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PaymentDetailType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Details of payment.
 * @subpackage Structs
 */
class PaymentDetailType extends PaymentFormType
{
    /**
     * The PaymentAmount
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\PaymentAmount
     */
    public $PaymentAmount;
    /**
     * The PaymentAmountInPayCur
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\PaymentAmountInPayCur
     */
    public $PaymentAmountInPayCur;
    /**
     * Constructor method for PaymentDetailType
     * @uses PaymentDetailType::setPaymentAmount()
     * @uses PaymentDetailType::setPaymentAmountInPayCur()
     * @param \StructType\PaymentAmount $paymentAmount
     * @param \StructType\PaymentAmountInPayCur $paymentAmountInPayCur
     */
    public function __construct(\StructType\PaymentAmount $paymentAmount = null, \StructType\PaymentAmountInPayCur $paymentAmountInPayCur = null)
    {
        $this
            ->setPaymentAmount($paymentAmount)
            ->setPaymentAmountInPayCur($paymentAmountInPayCur);
    }
    /**
     * Get PaymentAmount value
     * @return \StructType\PaymentAmount|null
     */
    public function getPaymentAmount()
    {
        return $this->PaymentAmount;
    }
    /**
     * Set PaymentAmount value
     * @param \StructType\PaymentAmount $paymentAmount
     * @return \StructType\PaymentDetailType
     */
    public function setPaymentAmount(\StructType\PaymentAmount $paymentAmount = null)
    {
        $this->PaymentAmount = $paymentAmount;
        return $this;
    }
    /**
     * Get PaymentAmountInPayCur value
     * @return \StructType\PaymentAmountInPayCur|null
     */
    public function getPaymentAmountInPayCur()
    {
        return $this->PaymentAmountInPayCur;
    }
    /**
     * Set PaymentAmountInPayCur value
     * @param \StructType\PaymentAmountInPayCur $paymentAmountInPayCur
     * @return \StructType\PaymentDetailType
     */
    public function setPaymentAmountInPayCur(\StructType\PaymentAmountInPayCur $paymentAmountInPayCur = null)
    {
        $this->PaymentAmountInPayCur = $paymentAmountInPayCur;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PaymentDetailType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
