<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PerPaxFlexifareBDS StructType
 * Meta informations extracted from the WSDL
 * - documentation: The breakdown of flexifare presented per pax wise
 * @subpackage Structs
 */
class PerPaxFlexifareBDS extends AbstractStructBase
{
    /**
     * The PerPaxFlexifareBD
     * Meta informations extracted from the WSDL
     * - documentation: Per Pax flexifare Break Down.
     * - maxOccurs: 10
     * @var mixed[]
     */
    public $PerPaxFlexifareBD;
    /**
     * Constructor method for PerPaxFlexifareBDS
     * @uses PerPaxFlexifareBDS::setPerPaxFlexifareBD()
     * @param mixed[] $perPaxFlexifareBD
     */
    public function __construct(array $perPaxFlexifareBD = array())
    {
        $this
            ->setPerPaxFlexifareBD($perPaxFlexifareBD);
    }
    /**
     * Get PerPaxFlexifareBD value
     * @return mixed[]|null
     */
    public function getPerPaxFlexifareBD()
    {
        return $this->PerPaxFlexifareBD;
    }
    /**
     * Set PerPaxFlexifareBD value
     * @throws \InvalidArgumentException
     * @param mixed[] $perPaxFlexifareBD
     * @return \StructType\PerPaxFlexifareBDS
     */
    public function setPerPaxFlexifareBD(array $perPaxFlexifareBD = array())
    {
        foreach ($perPaxFlexifareBD as $perPaxFlexifareBDSPerPaxFlexifareBDItem) {
            // validation for constraint: itemType
            if (!false) {
                throw new \InvalidArgumentException(sprintf('The PerPaxFlexifareBD property can only contain items of anyType, "%s" given', is_object($perPaxFlexifareBDSPerPaxFlexifareBDItem) ? get_class($perPaxFlexifareBDSPerPaxFlexifareBDItem) : gettype($perPaxFlexifareBDSPerPaxFlexifareBDItem)), __LINE__);
            }
        }
        $this->PerPaxFlexifareBD = $perPaxFlexifareBD;
        return $this;
    }
    /**
     * Add item to PerPaxFlexifareBD value
     * @throws \InvalidArgumentException
     * @param mixed $item
     * @return \StructType\PerPaxFlexifareBDS
     */
    public function addToPerPaxFlexifareBD($item)
    {
        // validation for constraint: itemType
        if (!false) {
            throw new \InvalidArgumentException(sprintf('The PerPaxFlexifareBD property can only contain items of anyType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PerPaxFlexifareBD[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PerPaxFlexifareBDS
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
