<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PlanRestrictionType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Contains all restrictions to coverage by the quoted or booked plan.
 * @subpackage Structs
 */
class PlanRestrictionType extends AbstractStructBase
{
    /**
     * The PlanRestriction
     * Meta informations extracted from the WSDL
     * - maxOccurs: 99
     * @var \StructType\PlanRestriction[]
     */
    public $PlanRestriction;
    /**
     * Constructor method for PlanRestrictionType
     * @uses PlanRestrictionType::setPlanRestriction()
     * @param \StructType\PlanRestriction[] $planRestriction
     */
    public function __construct(array $planRestriction = array())
    {
        $this
            ->setPlanRestriction($planRestriction);
    }
    /**
     * Get PlanRestriction value
     * @return \StructType\PlanRestriction[]|null
     */
    public function getPlanRestriction()
    {
        return $this->PlanRestriction;
    }
    /**
     * Set PlanRestriction value
     * @throws \InvalidArgumentException
     * @param \StructType\PlanRestriction[] $planRestriction
     * @return \StructType\PlanRestrictionType
     */
    public function setPlanRestriction(array $planRestriction = array())
    {
        foreach ($planRestriction as $planRestrictionTypePlanRestrictionItem) {
            // validation for constraint: itemType
            if (!$planRestrictionTypePlanRestrictionItem instanceof \StructType\PlanRestriction) {
                throw new \InvalidArgumentException(sprintf('The PlanRestriction property can only contain items of \StructType\PlanRestriction, "%s" given', is_object($planRestrictionTypePlanRestrictionItem) ? get_class($planRestrictionTypePlanRestrictionItem) : gettype($planRestrictionTypePlanRestrictionItem)), __LINE__);
            }
        }
        $this->PlanRestriction = $planRestriction;
        return $this;
    }
    /**
     * Add item to PlanRestriction value
     * @throws \InvalidArgumentException
     * @param \StructType\PlanRestriction $item
     * @return \StructType\PlanRestrictionType
     */
    public function addToPlanRestriction(\StructType\PlanRestriction $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PlanRestriction) {
            throw new \InvalidArgumentException(sprintf('The PlanRestriction property can only contain items of \StructType\PlanRestriction, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PlanRestriction[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PlanRestrictionType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
