<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PreexistingConditions StructType
 * Meta informations extracted from the WSDL
 * - documentation: Contains a description of the traveler's pre-existing conditions, the diagnosis date of the condition, and the date of last treatment.
 * @subpackage Structs
 */
class PreexistingConditions extends AbstractStructBase
{
    /**
     * The PreexistingCondition
     * Meta informations extracted from the WSDL
     * - maxOccurs: 99
     * @var \StructType\PreexistingCondition[]
     */
    public $PreexistingCondition;
    /**
     * Constructor method for PreexistingConditions
     * @uses PreexistingConditions::setPreexistingCondition()
     * @param \StructType\PreexistingCondition[] $preexistingCondition
     */
    public function __construct(array $preexistingCondition = array())
    {
        $this
            ->setPreexistingCondition($preexistingCondition);
    }
    /**
     * Get PreexistingCondition value
     * @return \StructType\PreexistingCondition[]|null
     */
    public function getPreexistingCondition()
    {
        return $this->PreexistingCondition;
    }
    /**
     * Set PreexistingCondition value
     * @throws \InvalidArgumentException
     * @param \StructType\PreexistingCondition[] $preexistingCondition
     * @return \StructType\PreexistingConditions
     */
    public function setPreexistingCondition(array $preexistingCondition = array())
    {
        foreach ($preexistingCondition as $preexistingConditionsPreexistingConditionItem) {
            // validation for constraint: itemType
            if (!$preexistingConditionsPreexistingConditionItem instanceof \StructType\PreexistingCondition) {
                throw new \InvalidArgumentException(sprintf('The PreexistingCondition property can only contain items of \StructType\PreexistingCondition, "%s" given', is_object($preexistingConditionsPreexistingConditionItem) ? get_class($preexistingConditionsPreexistingConditionItem) : gettype($preexistingConditionsPreexistingConditionItem)), __LINE__);
            }
        }
        $this->PreexistingCondition = $preexistingCondition;
        return $this;
    }
    /**
     * Add item to PreexistingCondition value
     * @throws \InvalidArgumentException
     * @param \StructType\PreexistingCondition $item
     * @return \StructType\PreexistingConditions
     */
    public function addToPreexistingCondition(\StructType\PreexistingCondition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PreexistingCondition) {
            throw new \InvalidArgumentException(sprintf('The PreexistingCondition property can only contain items of \StructType\PreexistingCondition, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PreexistingCondition[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PreexistingConditions
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
