<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SSRDetailsRequests StructType
 * Meta informations extracted from the WSDL
 * - documentation: The ssr details request element containing the details of the request.
 * @subpackage Structs
 */
class SSRDetailsRequests extends AbstractStructBase
{
    /**
     * The SSRDetailsRequest
     * Meta informations extracted from the WSDL
     * - maxOccurs: 99
     * - minOccurs: 0
     * @var \StructType\SSRDetailsRequest[]
     */
    public $SSRDetailsRequest;
    /**
     * Constructor method for SSRDetailsRequests
     * @uses SSRDetailsRequests::setSSRDetailsRequest()
     * @param \StructType\SSRDetailsRequest[] $sSRDetailsRequest
     */
    public function __construct(array $sSRDetailsRequest = array())
    {
        $this
            ->setSSRDetailsRequest($sSRDetailsRequest);
    }
    /**
     * Get SSRDetailsRequest value
     * @return \StructType\SSRDetailsRequest[]|null
     */
    public function getSSRDetailsRequest()
    {
        return $this->SSRDetailsRequest;
    }
    /**
     * Set SSRDetailsRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\SSRDetailsRequest[] $sSRDetailsRequest
     * @return \StructType\SSRDetailsRequests
     */
    public function setSSRDetailsRequest(array $sSRDetailsRequest = array())
    {
        foreach ($sSRDetailsRequest as $sSRDetailsRequestsSSRDetailsRequestItem) {
            // validation for constraint: itemType
            if (!$sSRDetailsRequestsSSRDetailsRequestItem instanceof \StructType\SSRDetailsRequest) {
                throw new \InvalidArgumentException(sprintf('The SSRDetailsRequest property can only contain items of \StructType\SSRDetailsRequest, "%s" given', is_object($sSRDetailsRequestsSSRDetailsRequestItem) ? get_class($sSRDetailsRequestsSSRDetailsRequestItem) : gettype($sSRDetailsRequestsSSRDetailsRequestItem)), __LINE__);
            }
        }
        $this->SSRDetailsRequest = $sSRDetailsRequest;
        return $this;
    }
    /**
     * Add item to SSRDetailsRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\SSRDetailsRequest $item
     * @return \StructType\SSRDetailsRequests
     */
    public function addToSSRDetailsRequest(\StructType\SSRDetailsRequest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SSRDetailsRequest) {
            throw new \InvalidArgumentException(sprintf('The SSRDetailsRequest property can only contain items of \StructType\SSRDetailsRequest, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SSRDetailsRequest[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SSRDetailsRequests
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
