<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SSRRequests StructType
 * Meta informations extracted from the WSDL
 * - documentation: A collection of SSR Request
 * @subpackage Structs
 */
class SSRRequests extends AbstractStructBase
{
    /**
     * The SSRRequest
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\SSRRequest[]
     */
    public $SSRRequest;
    /**
     * Constructor method for SSRRequests
     * @uses SSRRequests::setSSRRequest()
     * @param \StructType\SSRRequest[] $sSRRequest
     */
    public function __construct(array $sSRRequest = array())
    {
        $this
            ->setSSRRequest($sSRRequest);
    }
    /**
     * Get SSRRequest value
     * @return \StructType\SSRRequest[]|null
     */
    public function getSSRRequest()
    {
        return $this->SSRRequest;
    }
    /**
     * Set SSRRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\SSRRequest[] $sSRRequest
     * @return \StructType\SSRRequests
     */
    public function setSSRRequest(array $sSRRequest = array())
    {
        foreach ($sSRRequest as $sSRRequestsSSRRequestItem) {
            // validation for constraint: itemType
            if (!$sSRRequestsSSRRequestItem instanceof \StructType\SSRRequest) {
                throw new \InvalidArgumentException(sprintf('The SSRRequest property can only contain items of \StructType\SSRRequest, "%s" given', is_object($sSRRequestsSSRRequestItem) ? get_class($sSRRequestsSSRRequestItem) : gettype($sSRRequestsSSRRequestItem)), __LINE__);
            }
        }
        $this->SSRRequest = $sSRRequest;
        return $this;
    }
    /**
     * Add item to SSRRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\SSRRequest $item
     * @return \StructType\SSRRequests
     */
    public function addToSSRRequest(\StructType\SSRRequest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SSRRequest) {
            throw new \InvalidArgumentException(sprintf('The SSRRequest property can only contain items of \StructType\SSRRequest, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SSRRequest[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SSRRequests
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
