<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SeatMapRequests StructType
 * Meta informations extracted from the WSDL
 * - documentation: The seat map request element containing hte details of the request.
 * @subpackage Structs
 */
class SeatMapRequests extends AbstractStructBase
{
    /**
     * The SeatMapRequest
     * Meta informations extracted from the WSDL
     * - maxOccurs: 99
     * - minOccurs: 0
     * @var \StructType\SeatMapRequest[]
     */
    public $SeatMapRequest;
    /**
     * Constructor method for SeatMapRequests
     * @uses SeatMapRequests::setSeatMapRequest()
     * @param \StructType\SeatMapRequest[] $seatMapRequest
     */
    public function __construct(array $seatMapRequest = array())
    {
        $this
            ->setSeatMapRequest($seatMapRequest);
    }
    /**
     * Get SeatMapRequest value
     * @return \StructType\SeatMapRequest[]|null
     */
    public function getSeatMapRequest()
    {
        return $this->SeatMapRequest;
    }
    /**
     * Set SeatMapRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\SeatMapRequest[] $seatMapRequest
     * @return \StructType\SeatMapRequests
     */
    public function setSeatMapRequest(array $seatMapRequest = array())
    {
        foreach ($seatMapRequest as $seatMapRequestsSeatMapRequestItem) {
            // validation for constraint: itemType
            if (!$seatMapRequestsSeatMapRequestItem instanceof \StructType\SeatMapRequest) {
                throw new \InvalidArgumentException(sprintf('The SeatMapRequest property can only contain items of \StructType\SeatMapRequest, "%s" given', is_object($seatMapRequestsSeatMapRequestItem) ? get_class($seatMapRequestsSeatMapRequestItem) : gettype($seatMapRequestsSeatMapRequestItem)), __LINE__);
            }
        }
        $this->SeatMapRequest = $seatMapRequest;
        return $this;
    }
    /**
     * Add item to SeatMapRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\SeatMapRequest $item
     * @return \StructType\SeatMapRequests
     */
    public function addToSeatMapRequest(\StructType\SeatMapRequest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SeatMapRequest) {
            throw new \InvalidArgumentException(sprintf('The SeatMapRequest property can only contain items of \StructType\SeatMapRequest, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SeatMapRequest[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SeatMapRequests
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
