<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TravelerRefNumber StructType
 * Meta informations extracted from the WSDL
 * - documentation: Direct reference of traveler assigned by requesting system. Used as a cross reference between data segments.This value will be mapped to the RPH value in TravelRefNumber of the SeatMapRequest element | Direct reference of traveler
 * assigned by requesting system. Used as a cross reference between data segments.This value will be mapped to the RPH value in TravelRefNumber of the SeatMapRequest element | Direct reference of traveler assigned by requesting system. Used as a cross
 * reference between data segments.This value will be mapped to the RPH value in TravelRefNumber of the MealDetailsRequest element | Direct reference of traveler assigned by requesting system. Used as a cross reference between data segments.This value
 * will be mapped to the RPH value in TravelRefNumber of the MealDetailsRequest element | Direct reference of traveler assigned by requesting system. Used as a cross reference between data segments.This value will be mapped to the RPH value in
 * TravelRefNumber of the ssrDetailsRequest element | Direct reference of traveler assigned by requesting system. Used as a cross reference between data segments.This value will be mapped to the RPH value in TravelRefNumber of the ssrDetailsRequest
 * element | Direct reference of traveler assigned by requesting system. Used as a cross reference between data segments.This value will be mapped to the RPH value in TravelRefNumber of the BaggageDetailsRequest element | Direct reference of traveler
 * assigned by requesting system. Used as a cross reference between data segments.This value will be mapped to the RPH value in TravelRefNumber of the BaggageDetailsRequest element | Direct reference of traveler assigned by requesting system. Used as a
 * cross reference between data segments. | One or more travelers to whom this request applies | Contains the RPH reference to the traveler. | One or more travelers to whom this request applies
 * @subpackage Structs
 */
class TravelerRefNumber extends AbstractStructBase
{
    /**
     * The RPH
     * Meta informations extracted from the WSDL
     * - documentation: A unique reference for the traveler. | A unique reference for the traveler. | A unique reference for the traveler. | A unique reference for the traveler.
     * @var string
     */
    public $RPH;
    /**
     * The SurnameRefNumber
     * Meta informations extracted from the WSDL
     * - documentation: Used to identify and associate travelers with the same surname. | Used to identify and associate travelers with the same surname. | Used to identify and associate travelers with the same surname. | Used to identify and associate
     * travelers with the same surname.
     * @var string
     */
    public $SurnameRefNumber;
    /**
     * Constructor method for TravelerRefNumber
     * @uses TravelerRefNumber::setRPH()
     * @uses TravelerRefNumber::setSurnameRefNumber()
     * @param string $rPH
     * @param string $surnameRefNumber
     */
    public function __construct($rPH = null, $surnameRefNumber = null)
    {
        $this
            ->setRPH($rPH)
            ->setSurnameRefNumber($surnameRefNumber);
    }
    /**
     * Get RPH value
     * @return string|null
     */
    public function getRPH()
    {
        return $this->RPH;
    }
    /**
     * Set RPH value
     * @param string $rPH
     * @return \StructType\TravelerRefNumber
     */
    public function setRPH($rPH = null)
    {
        // validation for constraint: string
        if (!is_null($rPH) && !is_string($rPH)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rPH)), __LINE__);
        }
        $this->RPH = $rPH;
        return $this;
    }
    /**
     * Get SurnameRefNumber value
     * @return string|null
     */
    public function getSurnameRefNumber()
    {
        return $this->SurnameRefNumber;
    }
    /**
     * Set SurnameRefNumber value
     * @param string $surnameRefNumber
     * @return \StructType\TravelerRefNumber
     */
    public function setSurnameRefNumber($surnameRefNumber = null)
    {
        // validation for constraint: string
        if (!is_null($surnameRefNumber) && !is_string($surnameRefNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($surnameRefNumber)), __LINE__);
        }
        $this->SurnameRefNumber = $surnameRefNumber;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TravelerRefNumber
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
