<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TripFeaturesType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Information about the traveler(s) journey that is necessary for quoting/booking the insurance.
 * @subpackage Structs
 */
class TripFeaturesType extends AbstractStructBase
{
    /**
     * The Destinations
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Destinations
     */
    public $Destinations;
    /**
     * The Activities
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Activities
     */
    public $Activities;
    /**
     * The Operators
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Operators
     */
    public $Operators;
    /**
     * Constructor method for TripFeaturesType
     * @uses TripFeaturesType::setDestinations()
     * @uses TripFeaturesType::setActivities()
     * @uses TripFeaturesType::setOperators()
     * @param \StructType\Destinations $destinations
     * @param \StructType\Activities $activities
     * @param \StructType\Operators $operators
     */
    public function __construct(\StructType\Destinations $destinations = null, \StructType\Activities $activities = null, \StructType\Operators $operators = null)
    {
        $this
            ->setDestinations($destinations)
            ->setActivities($activities)
            ->setOperators($operators);
    }
    /**
     * Get Destinations value
     * @return \StructType\Destinations|null
     */
    public function getDestinations()
    {
        return $this->Destinations;
    }
    /**
     * Set Destinations value
     * @param \StructType\Destinations $destinations
     * @return \StructType\TripFeaturesType
     */
    public function setDestinations(\StructType\Destinations $destinations = null)
    {
        $this->Destinations = $destinations;
        return $this;
    }
    /**
     * Get Activities value
     * @return \StructType\Activities|null
     */
    public function getActivities()
    {
        return $this->Activities;
    }
    /**
     * Set Activities value
     * @param \StructType\Activities $activities
     * @return \StructType\TripFeaturesType
     */
    public function setActivities(\StructType\Activities $activities = null)
    {
        $this->Activities = $activities;
        return $this;
    }
    /**
     * Get Operators value
     * @return \StructType\Operators|null
     */
    public function getOperators()
    {
        return $this->Operators;
    }
    /**
     * Set Operators value
     * @param \StructType\Operators $operators
     * @return \StructType\TripFeaturesType
     */
    public function setOperators(\StructType\Operators $operators = null)
    {
        $this->Operators = $operators;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TripFeaturesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
